unit u_main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, filectrl, shellapi, ActnList,
  ShlObj, ActiveX, ComObj, Menus, ImgList, ComCtrls, IniFiles, ToolWin;
//{$IFDEF conditionalexpressions}{$IF version >= '150'}, xpman, ToolWin{$IFEND}{$ENDIF};

const
  WM_PERFORMAUTO = WM_USER + 8;
  WM_TASKICONEVENT = WM_USER + 9;
  WM_RUNAFTER = WM_USER + 10;

type
  // what events to log
  TLogInclude = (liError, liCopying, liDeletion);
  TWhatToLog = set of TLogInclude;

  // show current status, what type
  TStatusType = (stCopy, stDel);

  // options set
  TDCOptions = packed record
    oAuto: Boolean; // kein GUI
    oDel: Boolean; // loesche dateien, die nicht im quellpfad existieren
    oLogWhat: TWhatToLog; // besttigung oder logging
    oClose: Boolean; // automatisch schliessen nach aktion
    oLogName: string; // datei zum loggen
    oEventLog: Boolean; // ins event-log schreiben ?
    oNoNew: Boolean; // lsche keine neueren dateien im zielpfad
    oNoTime: Boolean; // vergleiche keine Zeitangabe
    oSetTime: Boolean; // Setze Dateizeit
    oStartCopy: Boolean; // kopiere direkt nach Vergleich
    oWhatIgA: Integer; // what attributes to ignore
    oDirList: TStrings; // liste der quell/ziel-verzeichnisse
    oRecSubs: Boolean; // untervz einlesen
    oForceReg: Boolean; // geladene regitry hives unter nt sichern und ueberschreiben (letzteres immer interaktiv)
    oRunFin: string; // application to run after copying is finished
    oNoEDir: Boolean; // don't create empty directories
    oCheckFile: string; // check this file before doing something
  end;

  TfmMain = class(TForm)
    alMain: TActionList;
    acOpenSet: TAction;
    acSaveSet: TAction;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Actions1: TMenuItem;
    acBuild: TAction;
    acExit: TAction;
    acShow: TAction;
    acDo: TAction;
    acUp: TAction;
    acDown: TAction;
    acNew: TAction;
    acDel: TAction;
    acprop: TAction;
    acLogging: TAction;
    ImageList1: TImageList;
    OpenSet1: TMenuItem;
    SaveSet1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    BuildList1: TMenuItem;
    ShowList1: TMenuItem;
    N3: TMenuItem;
    Do1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Up1: TMenuItem;
    Down1: TMenuItem;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Modify1: TMenuItem;
    acCancel: TAction;
    acSwapAll: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label3: TLabel;
    btn_log: TSpeedButton;
    cbDel: TCheckBox;
    CBRecurse: TCheckBox;
    RBConfirm: TRadioButton;
    RBLog: TRadioButton;
    lbNoAttr: TLabel;
    CBNoNew: TCheckBox;
    cbForceReg: TCheckBox;
    cbNoEDir: TCheckBox;
    Bevel5: TBevel;
    acDuplicate: TAction;
    acReset: TAction;
    Reset1: TMenuItem;
    Swappall1: TMenuItem;
    Copy1: TMenuItem;
    cbAttrR: TCheckBox;
    cbAttrS: TCheckBox;
    cbAttrH: TCheckBox;
    cbAttrA: TCheckBox;
    Bevel4: TBevel;
    Bevel6: TBevel;
    Label1: TLabel;
    edCheckFileName: TEdit;
    CheckBtn: TSpeedButton;
    Label2: TLabel;
    edRunFileName: TEdit;
    RunBtn: TSpeedButton;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    Panel3: TPanel;
    sb_up: TSpeedButton;
    sb_down: TSpeedButton;
    sb_new: TSpeedButton;
    sb_del: TSpeedButton;
    sb_Mod: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    lvFList: TListView;
    StatusBar1: TStatusBar;
    CBNoTime: TCheckBox;
    CBStartCopy: TCheckBox;
    CBSetTime: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CBRecurseClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RBConfirmClick(Sender: TObject);
    procedure RBLogClick(Sender: TObject);
    procedure acOpenSetExecute(Sender: TObject);
    procedure acSaveSetExecute(Sender: TObject);
    procedure lvFListChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure lvFListClick(Sender: TObject);
    procedure lvFListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvFListColumnClick(Sender: TObject; Column: TListColumn);
    procedure acBuildExecute(Sender: TObject);
    procedure acShowExecute(Sender: TObject);
    procedure acDoExecute(Sender: TObject);
    procedure acExitExecute(Sender: TObject);
    procedure acUpExecute(Sender: TObject);
    procedure acDownExecute(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
    procedure acDelExecute(Sender: TObject);
    procedure acpropExecute(Sender: TObject);
    procedure acLoggingExecute(Sender: TObject);
    procedure alMainUpdate(Action: TBasicAction; var Handled: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure acCancelExecute(Sender: TObject);
    procedure SetStatusText(const Text: string);
    function GetStatusText: string;
    procedure cbNoEDirClick(Sender: TObject);
    procedure cbDelClick(Sender: TObject);
    procedure lbNoAttrClick(Sender: TObject);
    procedure acSwapAllExecute(Sender: TObject);
    procedure PageControl1DrawTab(Control: TCustomTabControl;
      TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure acDuplicateExecute(Sender: TObject);
    procedure acResetExecute(Sender: TObject);
    procedure CheckBtnClick(Sender: TObject);
    procedure RunBtnClick(Sender: TObject);
    procedure edCheckFileNameKeyPress(Sender: TObject; var Key: Char);
    procedure edRunFileNameKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MRUFileList1MRUItemClick(Sender: TObject; AFilename: string);
  private
    { Private-Deklarationen }
    fFirst: Boolean;
    function buildlist: boolean;
    procedure DisableControls;
    procedure EnableControls;
    procedure FormHint(Sender: TObject);
    procedure FormMin(Sender: TObject);
    procedure FormRest(Sender: TObject);
    procedure OptsToGui(Opts: TDCOptions);
    procedure GUIToOpts(var FOpts: TDCOptions; const LogFile: string; const LogLevel: TWhatToLog; const ToEventLog: Boolean);
    procedure PrintStatus(const typ: TStatusType; const path: string);
    procedure WMPERFORMAUTO(var msg: TMessage); message WM_PERFORMAUTO;
    procedure WMTASKICONEVENT(var msg: TMessage); message WM_TASKICONEVENT;
    procedure WMRUNAFTER(var msg: TMessage); message WM_RUNAFTER;
    procedure WMTIMER(var msg: TWMTIMER); message WM_TIMER;
    procedure Build_click;
    procedure Do_click;
    procedure CalcSizes;
    procedure UpdateButtons;
    procedure Fehler(a: string; const TG: Boolean = True);
    procedure GetParamsFromControlFile(const fm: string; const ToGui: Boolean = False);
    procedure StoreParamsInControlFile(const fm: string);
    procedure NonPossibile;
    procedure DeleteEmptyDirs;
    procedure DeleteCheckFileFromDelList;
    procedure CreateTaskIcon;
    procedure DestroyTaskIcon;
    procedure HaltTaskIcon;
    procedure LogStart;
  public
    { Public-Deklarationen }
    function MakeParams: string;
    procedure DoCopying;
    property StatusText: string read GetStatusText write SetStatusText;
  end;

type
  PFileRec = ^TFileRec;
  TActReason = (arNewFile, arNewDir, arDelFile, arDelDir, arAttr, arSize, arDate);
  TActionDone = (adToDo, adSuccess, adFailed);
  TWhereLogged = (ltFile, ltEventLog);
  TDiffAttr = (daResetArchive, daSetArchive, daResetHidden, daSetHidden, daResetSysfile, daSetSysFile, daResetReadOnly, daSetReadOnly);
  TDiffAttrs = set of TDiffAttr;

  TFileRec = packed record
    Size_Src: Int64;
    Date_Src: TFILETIME;
    Name_Src: ShortString;

    Size_Dst: Int64;
    Date_Dst: TFILETIME;
    Name_Dst: ShortString;

    DiffAttr: TDiffAttrs;
    Reason: TActReason;
    IsDone: TActionDone;
  end;

  PLarge = ^TLarge;
  TLarge = packed record
    case Integer of
      0: (Low, High: DWORD);
      1: (Value: Int64);
  end;

  TGetDiskFreeSpaceEx = function(lpDirectoryName: PChar; var lpFreeBytesAvailableToCaller, lpTotalNumberOfBytes;
    lpTotalNumberOfFreeBytes: PLarge): BOOL; stdcall;

  TUpdateBarForm = procedure(const BC, BP, FC, FP: Int64; const Name: string) of object;

  TLogEventType = (leError, leInfo, leSeparator, leSuccess);

const
  MinSizePRG = 65536 * 8;
  FileAttrMask = FILE_ATTRIBUTE_READONLY or FILE_ATTRIBUTE_HIDDEN or FILE_ATTRIBUTE_SYSTEM or
    FILE_ATTRIBUTE_DIRECTORY or FILE_ATTRIBUTE_ARCHIVE;

  // option
  OPT_ARG = -2;
  OPT_UNKNOWN = -1;
  aeName = 'DCOPY17';

  SE_NOFORCEREG = $FFFFEE01;
  SE_NOAUTORESTOREREG = $FFFFEE02;

  //fehlernummern fuer halt()
  EN_NOLOG = 22; // kann nicht loggen
  EN_INVPAR = 87; // ungltiges parameterargument
  EN_INVDELFILE = 33; // ungltiger aufruf von delfile/dir (falsche reason)
  EN_INVDELLIST = 34; // ungltiger REASON in del-liste
  EN_INVCPLIST = 35; // ungltiger REASON in copy-liste
  EN_NOLIC = 27; // fehlende lizenz-datei
  EN_CHECKFILE = 28; // check-file fehlt
var
  fmMain: TfmMain;
  copylist, dellist: tList;
  fescape: boolean;
  pm17FromCf: Boolean = False;
  IsMinim: Boolean = False;
  Opts: TDCOptions;
  HasLogged: Boolean = False;
  OldErrM: UINT;
  UpdateBarForm: TUpdateBarForm = nil;
  GDFEx: TGetDiskFreeSpaceEx;
  kernel32: THandle;
  DCCEBuf: PByteArray;
  DoCont: Boolean = False;
  TaskIcon: Boolean = False;
  WasError: Boolean = False;
  NothingToDo: Boolean = False;
  FileToLoad: string;
  FileToWork: string;
  defcap: string;
  LoggedTo: TWhereLogged;

procedure FormPosSave(Form: TForm);
procedure FormPosLoad(Form: TForm);
function GetErrMsg: string;
function DiffAttrToStr(const da: TDiffAttrs): string;
function FAttrToStr(const fa: Integer): string;
function DiskGetFree(const root: string): Int64;
function FileGetSize(const path: string): Int64;
function DifferentFileTime(src, dst: TFileTime): Boolean;
function IsFileNewer(src, dst: TFileTime): Boolean;
function FileGetAttrMask(const sr: string): Integer;
function IsNT: Boolean;

function MPSelectDirectory(const Caption: string; const FirstSelection: WideString;
  const aLeft, aTop: Integer;
  out Directory: string): Boolean;

procedure LogError(log: string; const LogType: TLogEventType);

procedure ParseCmdLine;
function delfile(const a: tfilename; const Silent: Boolean = False): Boolean;
function DelFileOrDirAndLog(const a: tfilename; const Reason: TActReason): Boolean;

function FileTimeToStr(const ft: TFILETIME): string;
function FSizeW32FD(data: TWin32FindData): Int64;
function DelBackSlash(const str: string): string;
function NullFileTime: TFileTime;
function NewFileRec(const _SizeSrc: Int64; const _DateSrc: TFILETIME; const _NameSrc: ShortString; const _AttrSrc: Integer;
  const _SizeDst: Int64; const _DateDst: TFILETIME; const _NameDst: ShortString; const _AttrDst: Integer;
  const _Reason: TActReason; const IgnoreAttrs: Integer): PFileRec;
function CheckError(ErrMsg: string; const MType: TMsgDlgType = mtWarning;
  const Buttons: TMsgDlgButtons = [mbCancel, mbRetry, mbIgnore]; const HCTX: Integer = 0): Word;

function Readable(const val: Int64): string;
function ReadableTime(val: Integer): string;
function ReadableFileTime(const val: TFileTime): string;

procedure SetAppTitle(const msg: string);

implementation

uses u_list, u_log, u_prog, u_mod, u_str, u_regnt;

{$R *.DFM}

var
  ByteCount, FileCount, FileCountLeft, ByteCountCur, FileCountCur: Int64;
  gFirst: PItemIDList;
  gDeskTopFolder: IShellFolder;
  _Aborted: Boolean = False;
  ActionResult: TActionDone;
  IFileMask, EFileMask: TStringList;
  fTmpList: TStringList;
  TIData: TNotifyIconData;
  TIChar: Char = 'A';

const

  TIID = 1;
  TITID = 223;
  MS_SLEEP = 1;

// helper

procedure FormPosSave(Form: TForm);
var
  conf: TIniFile;
  pl: TWindowPlacement;
begin
  conf := TIniFile.Create(ChangeFileExt(Application.ExeName, '.conf'));
  try
    pl.length := SizeOf(TWindowPlacement);
    GetWindowPlacement(Form.Handle, @pl);
    conf.WriteInteger(Form.Name, 'State', Integer(Form.WindowState));
    conf.WriteInteger(Form.Name, 'x', pl.rcNormalPosition.Left);
    conf.WriteInteger(Form.Name, 'y', pl.rcNormalPosition.Top);
    conf.WriteInteger(Form.Name, 'r', pl.rcNormalPosition.Right);
    conf.WriteInteger(Form.Name, 'b', pl.rcNormalPosition.Bottom);
  finally
    conf.Free;
  end;
end;

procedure FormPosLoad(Form: TForm);
var
  conf: TIniFile;
  pl: TWindowPlacement;
begin
  conf := TIniFile.Create(ChangeFileExt(Application.ExeName, '.conf'));
  try
    pl.length := SizeOf(TWindowPlacement);
    GetWindowPlacement(Form.Handle, @pl);
    pl.rcNormalPosition.Left := conf.ReadInteger(Form.Name, 'x', pl.rcNormalPosition.Left);
    pl.rcNormalPosition.Top := conf.ReadInteger(Form.Name, 'y', pl.rcNormalPosition.Top);
    pl.rcNormalPosition.Right := conf.ReadInteger(Form.Name, 'r', pl.rcNormalPosition.Right);
    pl.rcNormalPosition.Bottom := conf.ReadInteger(Form.Name, 'b', pl.rcNormalPosition.Bottom);
    SetWindowPlacement(Form.Handle, @pl);
    Form.WindowState := TWindowState(conf.ReadInteger(Form.Name, 'State', Integer(Form.WindowState)));
  finally
    conf.Free;
  end;
end;

procedure MinimHalt(const int: Integer);
begin
  WasError := True;
  if (Opts.oAuto and Opts.oClose) or (Opts.oAuto and IsMinim)
    then
    Halt(int)
  else
  begin
    if Assigned(fmMain) and Assigned(fmMain.lvFList) and not fmMain.lvFList.Enabled then
    try
      fmMain.EnableControls;
      fmMain.acShow.Enabled := False;
      fmMain.acDo.Enabled := False;
    finally
    end;
    Abort;
  end;
end;

procedure MsgFehler(const ms: string);
var
  s: string;
begin
  SetForegroundWindow(Application.Handle);
  s := ms;
  if (Copy(s, 1, 2) = 'e#') or (Copy(s, 1, 2) = 'w#')
    then
    Delete(s, 1, 2);
  MessageDlg(s, mtError, [mbOK], 0);
end;

procedure RunFinal(FOpts: TDCOptions);
var
  ie: Integer;
begin
  if WinExec(PChar(FOpts.oRunFin), SW_SHOW) < 32 then
  begin
    ie := GetLastError;
    if (FOpts.oAuto and FOpts.oClose) then
    begin
      LogError(Format(emrfe, [Opts.oRunFin, GetErrMsg]), leError);
      SetLastError(ie);
      MinimHalt(ie);
    end
    else
    begin
      MsgFehler(Format(emrfe, [Opts.oRunFin, GetErrMsg]));
      MinimHalt(ie);
    end;
  end;
end;

function GetBeepStr: string;
begin
  Result := ExtractFilePath(Application.ExeName) + 'beeper.exe';
end;

function MakeDiffAttr(const SrcAttr, DiffAttr: Integer): TDiffAttrs;
begin
  Result := [];
  if Bool(DiffAttr and FILE_ATTRIBUTE_ARCHIVE) then
  begin
    if Bool(SrcAttr and FILE_ATTRIBUTE_ARCHIVE)
      then
      Include(Result, daSetArchive)
    else
      Include(Result, daResetArchive);
  end;
  if Bool(DiffAttr and FILE_ATTRIBUTE_SYSTEM) then
  begin
    if Bool(SrcAttr and FILE_ATTRIBUTE_SYSTEM)
      then
      Include(Result, daSetSysFile)
    else
      Include(Result, daResetSysFile);
  end;
  if Bool(DiffAttr and FILE_ATTRIBUTE_HIDDEN) then
  begin
    if Bool(SrcAttr and FILE_ATTRIBUTE_HIDDEN)
      then
      Include(Result, daSetHidden)
    else
      Include(Result, daResetHidden);
  end;
  if Bool(DiffAttr and FILE_ATTRIBUTE_READONLY) then
  begin
    if Bool(SrcAttr and FILE_ATTRIBUTE_READONLY)
      then
      Include(Result, daSetReadOnly)
    else
      Include(Result, daResetReadOnly);
  end;
end;

function DiffAttrToStr(const da: TDiffAttrs): string;
begin
  Result := '';
  if daResetHidden in da
    then
    Result := Result + '-h ';
  if daSetHidden in da
    then
    Result := Result + '+H ';
  if daResetReadOnly in da
    then
    Result := Result + '-r ';
  if daSetReadOnly in da
    then
    Result := Result + '+R ';
  if daResetArchive in da
    then
    Result := Result + '-a ';
  if daSetArchive in da
    then
    Result := Result + '+A ';
  if daResetSysFile in da
    then
    Result := Result + '-s ';
  if daSetSysFile in da
    then
    Result := Result + '+S ';
  Result := Trim(Result);
end;

function DifferentFileAttributes(const Attr1, Attr2, IgnoreMask: Integer): Boolean;
begin
  Result := ((Attr1 and FileAttrMask) and (not IgnoreMask)) <> ((Attr2 and FileAttrMask) and (not IgnoreMask))
end;

function FAttrToStr(const fa: Integer): string;
begin
  Result := '';
  if Bool(fa and FILE_ATTRIBUTE_SYSTEM)
    then
    Result := Result + 'S';
  if Bool(fa and FILE_ATTRIBUTE_HIDDEN)
    then
    Result := Result + 'H';
  if Bool(fa and FILE_ATTRIBUTE_ARCHIVE)
    then
    Result := Result + 'A';
  if Bool(fa and FILE_ATTRIBUTE_READONLY)
    then
    Result := Result + 'R';
end;

function StrToFAttr(const fa: string): Integer;
begin
  if StrToIntdef(fa, -1) <> -1
    then
    Result := StrToInt(fa)
  else
  begin
    Result := 0;
    if Bool(Pos('s', LowerCase(fa)))
      then
      Result := Result or FILE_ATTRIBUTE_SYSTEM;
    if Bool(Pos('h', LowerCase(fa)))
      then
      Result := Result or FILE_ATTRIBUTE_HIDDEN;
    if Bool(Pos('a', LowerCase(fa)))
      then
      Result := Result or FILE_ATTRIBUTE_ARCHIVE;
    if Bool(Pos('r', LowerCase(fa)))
      then
      Result := Result or FILE_ATTRIBUTE_READONLY;
  end;
end;


procedure CheckAdd(var List: TList; Rec: PFileRec);
var
  DoAdd: Boolean;
  i: Integer;
begin
  DoAdd := True;
  if List = CopyList then
  begin
    for i := 0 to Pred(List.Count) do
    begin
      if Assigned(List[i]) and (AnsiLowerCase(PFileRec(List[i])^.Name_Dst) = AnsiLowerCase(Rec^.Name_Dst))
        and (AnsiLowerCase(PFileRec(List[i])^.Name_Src) = AnsiLowerCase(Rec^.Name_Src)) then
      begin
        DoAdd := False;
        Break;
      end;
    end;
  end
  else
  begin
    for i := 0 to Pred(List.Count) do
    begin
      if Assigned(List[i]) and (AnsiLowerCase(PFileRec(List[i])^.Name_Src) = AnsiLowerCase(Rec^.Name_Src)) then
      begin
        DoAdd := False;
        Break;
      end;
    end;
  end;
  if not DoAdd
    then
    FreeMem(Rec, SizeOf(TFileRec))
  else
    List.Add(Rec);
end;

procedure SetAppTitle(const msg: string);
begin
  if not TaskIcon
    then
    Application.Title := msg
  else
  begin
    StrCopy(TIData.szTip, PChar(Copy(msg, 1, 64)));
    TIData.uFlags := NIF_TIP;
    Shell_NotifyIcon(NIM_MODIFY, @TIData);
  end;
end;

function MPDirectoryExists(const aPath: TFileName): Boolean;
var
  aAttr: Integer;
  sp: string;
begin
  Result := False;
  sp := DelBackSlash(aPath);
  if (Pos('\', sp) = 0) and (sp <> '')
    then
    sp := sp + '\';
  aAttr := GetFileAttributes(PChar(sp));
  if aAttr <> -1
    then
    if Bool(aAttr and FILE_ATTRIBUTE_DIRECTORY)
      then
      Result := True;
end;

function BackPos(const sub: Char; const str: string): Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := Length(str) downto 1 do
  begin
    if str[i] = sub then
    begin
      Result := i;
      Break;
    end;
  end;
end;

function ExtractFileMaskAndDir(const Path: string; var mask: string): string;
var
  i: Integer;
begin
  mask := '*';
  Result := DelBackSlash(Path);
  // letzen teil holen
  if Path <> '' then
  begin
    if Path[Length(Path)] = '\'
      then
      Result := DelBackSlash(Path)
    else
    begin
      if not MPDirectoryExists(Path) then
      begin
        i := BackPos('\', Path);
        if i > 0 then
        begin
          Result := Copy(Path, 1, i - 1);
          mask := Copy(Path, i + 1, MaxInt);
        end;
      end;
    end;
  end;
end;

function GetErrMsg: string;
var
  i: Cardinal;
begin
  i := GetLastError;
  if i = SE_NOFORCEREG
    then
    Result := rsenoforce
  else
    if i = SE_NOAUTORESTOREREG
      then
      Result := rsenoautorest
    else
      Result := SysErrorMessage(GetLastError);
  if Result <> ''
    then
    for i := Length(Result) downto 0
      do
      if (Result[i] = #13)
        then
        Delete(Result, i, 1)
      else
        if (Result[i] = #10)
          then
          Result[i] := ' ';
end;

function IsNT: Boolean;
begin
  Result := Win32PlatForm = VER_PLATFORM_WIN32_NT;
end;

procedure AddToLog(const FName, Message: string; const ToEventLog: Boolean; const LogType: TLogEventType);
var
  h: THandle;
  msg: string;
  w: Cardinal;
begin
  if IsNT and ToEventLog then
  begin
    if RegisterEventLogApp then
    begin
      LoggedTo := ltEventLog;
      if LogType <> leSeparator then
      begin
        if not LogNTEvent(Message, LogType) then
        begin
          MessageBox(0, PChar(rsmwev), PChar(rsmefat), MB_ICONSTOP);
          MinimHalt(EN_NOLOG);
        end;
      end;
    end
    else
    begin
      Opts.oEventLog := False;
      AddToLog(FName, Format(rsmwevn, [GetErrMsg]), False, leError);
      AddToLog(FName, Message, False, LogType);
    end;
  end
  else
  begin
    LoggedTo := ltFile;
    msg := Message + #13#10;
    if Pos('w#', msg) = 1 then
    begin
      Delete(Msg, 1, 2);
      msg := rmrw + msg;
    end
    else
      if Pos('e#', msg) = 1 then
      begin
        Delete(Msg, 1, 2);
        msg := rmre + msg;
      end;
    ForceDirectories(ExtractFilePath(FName));
    h := CreateFile(PChar(FName), GENERIC_WRITE, FILE_SHARE_WRITE or FILE_SHARE_READ, nil, OPEN_ALWAYS,
      FILE_FLAG_BACKUP_SEMANTICS, 0);
    if h = INVALID_HANDLE_VALUE then
    begin
      MessageBox(0, PChar(Format(rsmwl, [FName])), PChar(rsmefat), MB_ICONSTOP);
      MinimHalt(EN_NOLOG);
    end;
    SetFilePointer(h, 0, nil, FILE_END);
    WriteFile(h, msg[1], Length(msg), w, nil);
    CloseHandle(h);
  end;
end;

function FileGetAttrMask(const sr: string): Integer;
begin
  Result := FileGetAttr(sr) and FileAttrMask;
end;

procedure clearlist(var val: tlist);
var
  ct: integer;
begin
  if Assigned(Val) and (val.count > 0)
    then
    for ct := 0 to val.count - 1
      do
      if assigned(val[ct])
        then
        FreeMem(PFileRec(val[ct]));
  val.clear;
end;

function SetPrivilege(const Privilege: string): boolean;
begin
  Result := ChangePrivilege(Privilege, SE_PRIVILEGE_ENABLED);
end;

function UnSetPrivilege(const Privilege: string): boolean;
begin
  Result := ChangePrivilege(Privilege, 0);
end;

function DifferentFileTime(src, dst: TFileTime): Boolean;
var
  LocalFileTime: TFileTime;
  tm1, tm2: Int64;
begin
  FileTimeToLocalFileTime(src, LocalFileTime);
  CopyMemory(@tm1, @LocalFileTime, SizeOf(tm1));
  FileTimeToLocalFileTime(dst, LocalFileTime);
  CopyMemory(@tm2, @LocalFileTime, SizeOf(tm2));
  // testen, ob zeiten maximal zwei sekunden auseinanderliegen (wegen FAT16-auflsung)
  Result := (ABS(tm2 - tm1) > 2E9);
end;

function IsFileNewer(src, dst: TFileTime): Boolean;
var
  L1, l2: TFileTime;
begin
  Result := DifferentFileTime(src, dst);
  if Result then
  begin
    FileTimeToLocalFileTime(src, l1);
    FileTimeToLocalFileTime(dst, l2);
    Result := CompareFileTime(l1, l2) > 0;
  end;
end;

function TestAction(action: TAction): Boolean;
begin
  Result := Assigned(Action) and Assigned(Action.OnExecute);
end;

procedure InitExProcs;
var
  lpFunc: Pointer;
begin
  GDFEx := nil;
  kernel32 := LoadLibrary('Kernel32.dll');
  if kernel32 <> 0 then
  begin
    lpFunc := GetProcAddress(kernel32, 'GetDiskFreeSpaceExA');
    if lpFunc <> nil then
    begin
      @GDFEx := lpFunc;
    end;
  end;
  GetMem(DCCEBuf, MinSizePrg);
end;

procedure FinalExProcs;
begin
  GDFEx := nil;
  FreeMem(DCCEBuf, MinSizePrg);
  if kernel32 <> 0
    then
    FreeLibrary(kernel32);
end;

function Readable(const val: Int64): string;
begin
  Result := Format('%.0n', [val + 0.0]);
end;

function ReadableTime(val: Integer): string;
var
  h, m, s: Integer;
begin
  Result := '';
  h := val div 3600;
  val := val mod 3600;
  m := val div 60;
  s := val mod 60;
  if h > 0
    then
    Result := Format('%.2d:%.2d:%.2d', [h, m, s])
  else
    if m > 0
      then
      Result := Format('%.2d:%.2d', [m, s])
    else
      Result := Format('00:%.2d', [s])
end;

function ReadableFileTime(const val: TFileTime): string;
var
  i: Integer;
  lft: _FILETIME;
begin
  FileTimeToLocalFileTime(val, lft);
  FileTimeToDosDateTime(lft, LongRec(i).Hi, LongRec(i).Lo);
  Result := FormatDateTime(rsmft, FileDateToDateTime(i));
end;

function GetDiskFreeSpaceExOrNot(alpDirectoryName: PChar; var alpFreeBytesAvailableToCaller, alpTotalNumberOfBytes;
  alpTotalNumberOfFreeBytes: PLarge): BOOL;

var
  lintSectorsPerCluster, lintBytesPerSector,
    lintNumberOfFreeClusters, lintTotalNumberOfClusters: Cardinal;
  lintBytesPerCluster: Cardinal;
begin
  Result := False;
  if Assigned(GDFEx) then
  begin
    if GDFEx(alpDirectoryName, alpFreeBytesAvailableToCaller, alpTotalNumberOfBytes,
      alpTotalNumberOfFreeBytes)
      then
      Result := True;
  end;
  if not Result then
  begin
    // either the api doesn't exist or something different has gone wrong, so let us try
    // a conventional GetDiskFreeSpace
    Result := GetDiskFreeSpace(alpDirectoryName, lintSectorsPerCluster, lintBytesPerSector,
      lintNumberOfFreeClusters, lintTotalNumberOfClusters);
    if Result then
    begin
      // now build the "right" return variables
      lintBytesPerCluster := lintSectorsPerCluster * lintBytesPerSector;
      TLarge(alpFreeBytesAvailableToCaller).Value := lintBytesPerCluster * lintNumberOfFreeClusters;
      TLarge(alpTotalNumberOfFreeBytes^).Value := lintBytesPerCluster * lintNumberOfFreeClusters;
      TLarge(alpTotalNumberOfBytes).Value := lintBytesPerCluster * lintTotalNumberOfClusters;
    end;
  end;
end;

function DiskGetFree(const root: string): Int64;
var
  vl, d1, d2: TLarge;
begin
  Result := -1;
  if GetDiskFreeSpaceExOrNot(PChar(root), vl, d1, @d2)
    then
    Result := vl.Value;
end;

function FileGetSize(const path: string): Int64;
var
  dt: TWin32FindData;
  h: THandle;
begin
  Result := -1;
  h := FindFirstFile(PChar(Path), dt);
  if h <> INVALID_HANDLE_VALUE then
  begin
    Result := FSizeW32FD(dt);
    Windows.FindClose(h);
  end;
end;

procedure InitOpts(var Opts: TDCOptions); // standardwerte einstellen
begin
  with Opts do
  begin
    oAuto := False;
    oDel := False;
    oLogWhat := [];
    oClose := False;
    oLogName := ExtractFilePath(ParamStr(0)) + 'error.txt';
    oEventLog := False;
    oNoNew := False;
    oNoTime:= True;
    oSetTime:= True;
    oStartCopy:= True;
    oWhatIgA := FILE_ATTRIBUTE_ARCHIVE;
    oRecSubs := True;
    oForceReg := False;
    oRunFin := '';
    oCheckFile := '';
    oNoEDir := False;
    if Assigned(oDirList) then
    begin
      oDirList.Free;
      oDirList := nil;
    end;
    oDirList := TStringList.Create;
  end;
end;

procedure ClearOpts(var Opts: TDCOptions); // standardwerte einstellen
begin
  with Opts do
  begin
    if Assigned(oDirList) then
    begin
      oDirList.Free;
      oDirList := nil;
    end;
  end;
end;

function TryPercent(const cur, p100: Int64): Int64;
begin
  if (p100 = 0) or (cur = 0)
    then
    Result := 0
  else
    Result := Round((cur / p100) * 100);
end;

function GetPercent(const msg: string; const cur, p100: Int64): string;
begin
  if p100 = 0
    then
    Result := ''
  else
    Result := Format('(%s%s%%)', [msg, IntToStr(Round((cur / p100) * 100))]);
end;

function NullFileTime: TFileTime;
begin
  Result.dwLowDateTime := 0;
  Result.dwHighDateTime := 0;
end;

function NewFileRec(const _SizeSrc: Int64; const _DateSrc: TFILETIME; const _NameSrc: ShortString; const _AttrSrc: Integer;
  const _SizeDst: Int64; const _DateDst: TFILETIME; const _NameDst: ShortString; const _AttrDst: Integer;
  const _Reason: TActReason; const IgnoreAttrs: Integer): PFileRec;
begin
  GetMem(Result, SizeOf(TFileRec));
  with Result^ do
  begin
    Size_Src := _SizeSrc;
    Date_Src := _DateSrc;
    Name_Src := _NameSrc;
    Size_Dst := _SizeDst;
    Date_Dst := _DateDst;
    Name_Dst := _NameDst;
    Reason := _Reason;
    IsDone := adToDo;
    // unterschiedliche attribute berechnen
    DiffAttr := MakeDiffAttr(_AttrSrc, ((_AttrSrc and FileAttrMask) xor (_AttrDst and FileAttrMask)) and (not IgnoreAttrs));
  end;
end;

function FSizeW32FD(data: TWin32FindData): Int64;
begin
  Result := data.nFileSizeLow + (data.nFileSizeHigh shl 32);
end;

function FileTimeToStr(const ft: TFILETIME): string;
var
  lft: TFileTime;
  dft: Integer;
begin
  FileTimeToLocalFileTime(ft, lft);
  FileTimeToDosDateTime(lft, LongRec(dft).Hi, LongRec(dft).Lo);
  Result := DateTimeToStr(FileDateToDateTime(dft));
end;

const
  tfStr: array[False..True] of string = ('FALSE', 'TRUE');

function CheckBoolVal(const sr: string): Boolean;
begin
  Result := (sr = '1') or (lstrcmpi(PChar(sr), PChar(tfstr[True])) = 0);
end;

function IntToWhatToLog(const i: Integer): TWhatToLog;
begin
  Result := [];
  case i of
    1: Result := [liCopying, liDeletion, liError];
    2: Result := [liCopying, liDeletion];
    3: Result := [liError];
  end;
end;

function SetToWhatToLog(const s: string): TWhatToLog;
begin
  Result := [];
  if Bool(Pos('E', UpperCase(s)))
    then
    Include(Result, liError);
  if Bool(Pos('D', UpperCase(s)))
    then
    Include(Result, liDeletion);
  if Bool(Pos('C', UpperCase(s)))
    then
    Include(Result, liCopying);
end;

procedure TfmMain.GetParamsFromControlFile(const fm: string; const ToGui: Boolean = False);
var
  Opts1: TDCOptions;
  sl: TStrings;
  i: Integer;
begin
  Opts1.oDirList := nil;
  InitOpts(Opts1);
  try
    sl := TStringList.Create;
    try
      try
        sl.LoadFromFile(fm);
      except
        fehler(Format(rsmnc, [fm]), ToGUI);
        exit;
      end;
      if sl.Count < 1 then
      begin
        fehler(Format(rsmrc, [fm]), ToGUI);
        exit;
      end;
      if Pos('cfg: ' + defcapr, sl[0]) <> 1 then
      begin
        if Pos('cfg: DiffCopy V1.7', sl[0]) <> 1 then
        begin
          fehler(Format(rsmrc, [fm]), ToGUI);
          exit;
        end;
      end;
      Opts1.oAuto := CheckBoolVal(sl.Values['Auto']);
      Opts1.oDel := CheckBoolVal(sl.Values['Del']);
      if sl.IndexOfName('LogLevel') > -1
        then
        Opts1.oLogWhat := IntToWhatToLog(StrToIntDef(sl.Values['LogLevel'], 0));
      // neu ab 1.71 satz von logwhat
      if sl.IndexOfName('LogMode') > -1
        then
        Opts1.oLogWhat := SetToWhatToLog(sl.Values['LogMode']);
      Opts1.oClose := CheckBoolVal(sl.Values['Close']);
      Opts1.oLogName := sl.Values['LogFile'];
      Opts1.oEventLog := CheckBoolVal(sl.Values['EventLog']) and RegisterEventLogApp;
      Opts1.oNoNew := CheckBoolVal(sl.Values['NoNew']);
      if sl.IndexOfName('NoAttr') > -1 then
      begin
        if CheckBoolVal(sl.Values['NoAttr'])
          then
          Opts1.oWhatIgA := FileAttrMask
        else
          Opts1.oWhatIgA := 0;
      end;
      if sl.IndexOfName('IgnoreAttributes') > -1
        then
        Opts1.oWhatIgA := StrToFAttr(sl.Values['IgnoreAttributes']);
      Opts1.oRecSubs := CheckBoolVal(sl.Values['Recurse']);
      Opts1.oForceReg := CheckBoolVal(sl.Values['ForceRegistry']) and IsNT;
      if CheckBoolVal(sl.Values['Beep'])
        then
        Opts1.oRunFin := GetBeepStr;
      if sl.IndexOfName('CheckFile') > -1
        then
        Opts1.oCheckFile := sl.Values['CheckFile'];
      if sl.IndexOfName('runafter') > -1
        then
        Opts1.oRunFin := sl.Values['runafter'];
      Opts1.oNoEDir := CheckBoolVal(sl.Values['NoEmptyDirs']);
      i := StrToIntDef(sl.Values['DCount'], 0);
      if i > 0
        then
        for i := 1 to i
          do
          Opts1.oDirList.Add(sl.Values['D' + IntToStr(i)]);
    finally
      sl.Free;
    end;
    if ToGui
      then
      OptsToGUI(Opts1)
    else
    begin
      Opts := Opts1;
      Opts1.oDirList := nil;
    end;
    Opts.oLogWhat := Opts1.oLogWhat;
    Opts.oLogName := Opts1.oLogName;
    Opts.oEventLog := Opts1.oEventLog;
    pm17FromCf := True;
    if Assigned(CopyList)
      then
      NonPossibile;
  finally
    ClearOpts(Opts1);
  end;
end;

function SetToStr(const s: TWhatToLog): string;
begin
  Result := '';
  if liError in s
    then
    Result := 'e';
  if liCopying in s
    then
    Result := Result + 'c';
  if liDeletion in s
    then
    Result := Result + 'd';
end;

procedure TfmMain.StoreParamsInControlFile(const fm: string);
var
  Opts1: TDCOptions;
  sl: TStrings;
  i: Integer;
begin
  Opts1.oDirList := nil;
  InitOpts(Opts1);
  try
    GUIToOpts(Opts1, Opts.oLogName, Opts.oLogWhat, Opts.oEventLog);
    sl := TStringList.Create;
    try
      sl.Add('cfg: ' + defcapr + ' Config file');
      sl.Add('Auto=' + tfStr[Opts1.oAuto]);
      sl.Add('Del=' + tfStr[Opts1.oDel]);
      sl.Add('LogMode=' + SetToStr(Opts1.oLogWhat));
      sl.Add('Close=' + tfStr[Opts1.oClose]);
      sl.Add('LogFile=' + Opts1.oLogName);
      sl.Add('EventLog=' + tfStr[Opts1.oEventLog]);
      sl.Add('NoNew=' + tfStr[Opts1.oNoNew]);
      sl.Add('IgnoreAttributes=' + FAttrToStr(Opts1.oWhatIgA));
      sl.Add('Recurse=' + tfStr[Opts1.oRecSubs]);
      sl.Add('ForceRegistry=' + tfStr[Opts1.oForceReg]);
      sl.Add('runafter=' + Opts1.oRunFin);
      sl.Add('CheckFile=' + Opts1.oCheckFile);
      sl.Add('NoEmptyDirs=' + tfStr[Opts1.oNoEDir]);
      sl.Add('DCount=' + IntToStr(Opts1.oDirList.Count));
      if Opts1.oDirList.Count > 0
        then
        for i := 0 to Pred(Opts1.oDirList.Count)
          do
          sl.Add('D' + IntToStr(i + 1) + '=' + Opts1.oDirList[i]);
      try
        sl.SaveToFile(fm);
      except
        MsgFehler(Format(rsmwc, [fm]));
      end;
    finally
      sl.Free;
    end;
    pm17FromCf := True;
  finally
    ClearOpts(Opts1);
  end;
end;

procedure TFmMain.Fehler(a: string; const TG: Boolean);
begin
  if TG then
  begin
    acShow.Enabled := False;
    acDo.Enabled := False;
  end;
  if a <> '' then
  begin
    if not IsMinim
      then
      MsgFehler(a)
    else
    begin
      Application.Restore;
      AddToLog(Opts.oLogName, a, Opts.oEventLog, leError);
      HasLogged := True;
      MsgFehler(a);
    end;
  end;
end;

procedure LogError(log: string; const LogType: TLogEventType);
begin
  if Opts.oLogWhat = []
    then
    Exit;
  AddToLog(Opts.oLogName, log, Opts.oEventLog, LogType);
  HasLogged := True;
end;

function GetOpt_MP(const i: Integer; var param: string; var nexti: Integer): Integer;
const
  _opts: array[0..24] of string = (
    'controlfile:',
    '-cf:',
    '!del',
    '!recurse',
    'confirm',
    'log',
    '!newfiles',
    '!auto',
    '!attribs',
    '!close',
    'logfile:',
    '-lf:',
    'logmode:',
    '-lm:',
    '!beep',
    '__edit__:',
    '__edfi__:',
    '!eventlog',
    '!forcereg',
    '!emptydirs',
    'loglevel:',
    '-ll:',
    'igattr:',
    'checkfile:',
    'runafter:');
var
  sr: string;
  srlc: string;
  sro: string;
  n: Integer;
  needarg: Boolean;
  decr: Integer;
  canno: Boolean;
begin
  param := '';
  nexti := i + 1;
  sr := ParamStr(i);
  srlc := AnsiLowerCase(sr);
  if (Copy(sr, 1, 1) = '/') or (Copy(sr, 1, 1) = '-') then
  begin
    Result := OPT_UNKNOWN;
    Delete(srlc, 1, 1);
    Delete(sr, 1, 1);
    // option
    for n := 0 to HIGH(_opts) do
    begin
      needarg := False;
      decr := 0;
      canno := False;
      sro := _opts[n];
      // flags setzen
      if sro[1] = '-' then
      begin
        Delete(sro, 1, 1);
        decr := 1;
      end;
      if sro[1] = '!' then
      begin
        delete(sro, 1, 1);
        canno := True;
      end;
      if sro[Length(sro)] = ':' then
      begin
        delete(sro, Length(sro), 1);
        needarg := True;
      end;

      if needarg then
      begin
        // testen, ob argument vorhanden
        if srlc = sro then
        begin
          param := ParamStr(i + 1);
          Inc(Nexti);
          Result := n;
        end
        else
        begin
          if Pos(sro + ':', srlc) = 1 then
          begin
            Result := n;
            param := Copy(sr, Pos(':', sr) + 1, MaxInt);
          end;
        end
      end
      else
      begin
        if srlc = sro then
        begin
          Result := n;
          if canno
            then
            param := 't';
        end
        else
          if canno and ('no' + sro = srlc) then
          begin
            Result := n;
            param := 'f';
          end;
      end;
      if Result <> OPT_UNKNOWN then
      begin
        Dec(Result, decr);
        Break;
      end;
    end;
  end
  else
  begin
    // keine option, sondern argument
    Result := OPT_ARG;
    param := sr;
  end;
end;


procedure ParseCmdLine;
var
  ct: Integer;
  par: string;
  cmd: Integer;
begin
  InitOpts(Opts);
  if (ParamCount = 1) and FileExists(ParamStr(1)) then
  begin
    fmMain.GetParamsFromControlFile(ParamStr(1));
    exit;
  end;
  if ParamCount > 0 then
  begin
    ct := 1;
    while (ct <= ParamCount) do
    begin
      cmd := GetOpt_MP(ct, par, ct);
      case cmd of
        OPT_UNKNOWN:
          begin
            if (Opts.oAuto and Opts.oClose) then
            begin
              LogError(Format(emfip, [ParamStr(ct - 1), DateTimeToStr(now)]), leError);
              SetLastError(EN_INVPAR);
              MinimHalt(EN_INVPAR);
            end
            else
            begin
              MsgFehler(Format(rseup, [ParamStr(ct - 1)]));
              MinimHalt(EN_INVPAR);
            end;
          end;
        OPT_ARG: Opts.oDirList.Add(par);
        0: // controlfile/cf
          if FileExists(par) then
          begin
            fmMain.GetParamsFromControlFile(par);
          end;
        2: Opts.oDel := (par = 't');
        3: Opts.oRecSubs := (par = 't');
        4: Opts.oLogWhat := [];
        5: Opts.oLogWhat := [liError];
        6: Opts.oNoNew := (par = 'f');
        7: Opts.oAuto := par = 't';
        8: if (par = 'f') then Opts.oWhatIgA := FileAttrMask else Opts.oWhatIgA := 0;
        9: Opts.oClose := par = 't';
        10: Opts.oLogName := par;
        12: if Opts.oLogWhat <> []
          then
            Opts.oLogWhat := SetToWhatToLog(par);
        14: if par = 't' then Opts.oRunFin := GetBeepStr;
        //15:
        16: FileToWork := par;
        17: Opts.oEventLog := (par = 't') and IsNT and RegisterEventLogApp;
        18: Opts.oForceReg := (par = 't') and IsNT;
        19: Opts.oNoEDir := (par = 'f');
        20: Opts.oLogWhat := IntToWhatToLog(StrToIntDef(par, 0));
        22: Opts.oWhatIgA := StrToFAttr(par);
        23: Opts.oCheckFile := par;
        24: Opts.oRunFin := par;
      end;
    end;
  end;
  if not Opts.oAuto then
  begin
    Opts.oClose := False;
  end;
end;

function setattr(src, dst: string): boolean; overload;
var
  ct: integer;
begin
  result := true;
  if Opts.oWhatIgA = FileAttrMask
    then
    Exit;
  ct := FileGetAttrMask(src);
  if (ct <> -1) and (filesetattr(dst, ct) = 0) and (FileGetAttrMask(dst) = ct)
    then
    exit
  else
  begin
    case CheckError(Format(rsmsea, [dst, src, GetErrMsg])) of
      mrcancel:
        begin
          result := false;
          exit;
        end;
      mrretry:
        begin
          result := setattr(dst, src);
          exit;
        end;
      mrignore: exit;
    end;
  end;
end;

function GetNewAttribs(const fn: string; const Diff: TDiffAttrs): Integer;
begin
  Result := FileGetAttrMask(fn);
  if Result <> -1 then
  begin
    if daResetArchive in Diff
      then
      Result := Result and (not FILE_ATTRIBUTE_ARCHIVE);
    if daSetArchive in Diff
      then
      Result := Result or FILE_ATTRIBUTE_ARCHIVE;
    if daResetHidden in Diff
      then
      Result := Result and (not FILE_ATTRIBUTE_HIDDEN);
    if daSetHidden in Diff
      then
      Result := Result or FILE_ATTRIBUTE_HIDDEN;
    if daResetSysFile in Diff
      then
      Result := Result and (not FILE_ATTRIBUTE_SYSTEM);
    if daSetSysFile in Diff
      then
      Result := Result or FILE_ATTRIBUTE_SYSTEM;
    if daResetReadOnly in Diff
      then
      Result := Result and (not FILE_ATTRIBUTE_READONLY);
    if daSetReadOnly in Diff
      then
      Result := Result or FILE_ATTRIBUTE_READONLY;
  end;
end;

function setattr(const fname: string; const DiffAttr: TDiffAttrs): boolean; overload;
var
  ct: integer;
begin
  result := true;
  if Opts.oWhatIgA = FileAttrMask
    then
    Exit;
  ct := GetNewAttribs(fname, DiffAttr);
  if (ct <> -1) and (filesetattr(fname, ct) = 0) and (FileGetAttrMask(fname) = ct)
    then
    exit
  else
  begin
    case CheckError(Format(rsmsead, [fname, GetErrMsg])) of
      mrcancel:
        begin
          result := false;
          exit;
        end;
      mrretry:
        begin
          result := setattr(fname, DiffAttr);
          exit;
        end;
      mrignore: exit;
    end;
  end;
end;

function DC_Touch(const src, dst: string): Boolean;
var
  FileTime: TFileTime;
  tm: TFileTime;
  Age: Integer;
  hs, ht: THandle;
  data: TWin32FindData;
  LST: TSystemTime;
begin
  ZeroMemory(@data, SizeOf(Data));
  Result := False;
  hs := FindFirstFile(PChar(src), data);
  if hs <> INVALID_HANDLE_VALUE then
  begin
    Age:=DateTimeToFileDate(Date());
    DosDateTimeToFileTime(LongRec(Age).Hi, LongRec(Age).Lo, tm);
    LocalFileTimeToFileTime(tm, FileTime);
    Windows.FindClose(hs);
    tm := data.ftLastWriteTime;
    ht := CreateFile(PChar(dst), GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
    if ht <> INVALID_HANDLE_VALUE then
    begin
      if Opts.oSetTime then
      begin
         Result := SetFileTime(ht, @data.ftCreationtime, @data.ftlastAccesstime, @FileTime);
      end
      else
      begin
         Result := SetFileTime(ht, @data.ftCreationtime, @data.ftlastAccesstime, @data.ftLastWriteTime);
      end;
      CloseHandle(ht);
    end;
  end;

end;

function DC_CopyFileEx(const src, dst: string): Boolean;
var
  srch, trgh: Integer;
  n, n1: Int64;
  CurTrans: Int64;
  E: DWORD;
begin
  Result := False;
  Sleep(MS_SLEEP);
  E := SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    CurTrans := 0;
    srch := CreateFile(PChar(src), GENERIC_READ, FILE_SHARE_WRITE or FILE_SHARE_READ, nil, OPEN_EXISTING,
      FILE_FLAG_BACKUP_SEMANTICS, 0);

    if srch = -1
      then
      Exit;

    trgh := CreateFile(PChar(dst), GENERIC_WRITE, FILE_SHARE_WRITE or FILE_SHARE_READ, nil, CREATE_ALWAYS,
      FILE_FLAG_BACKUP_SEMANTICS, 0);

    if trgh = -1 then
    begin
      delfile(dst, True);
      trgh := FileCreate(dst);
      if trgh = -1 then
      begin
        FileClose(srch);
        Exit;
      end;
    end;

    try
      repeat
        Sleep(MS_SLEEP);
        n := FileRead(srch, DCCEBuf^, MinSizePrg);
        if (n <= 0)
          then
          Break;
        n1 := FileWrite(trgh, DCCEBuf^, n);
        if (n <> n1) or fEscape then
        begin
          FileClose(srch);
          FileClose(trgh);
          Exit;
        end;

        Inc(CurTrans, n1);
        if (not IsMinim) and Assigned(UpdateBarForm) then
        begin
          UpdateBarForm(ByteCountCur + CurTrans, TryPercent(ByteCountCur + CurTrans, ByteCount),
            FileCountCur, TryPercent(FileCountCur, FileCount), dst);
          Application.ProcessMessages;
        end;
      until n < MinSizePrg;

      FileClose(srch);
      FileClose(trgh);

      Result := True;
    except
      Exit;
    end;
  finally
    SetErrorMode(E);
  end;
end;

function Touch(const src, dst: string): Boolean;
begin
  Result := DC_Touch(src, dst);
  if not Result
    then
    case CheckError(Format(rsmset, [dst, src, GetErrMsg])) of
      mrcancel:
        begin
          result := false;
          exit;
        end;
      mrretry:
        begin
          result := Touch(src, dst);
          exit;
        end;
      mrignore: Result := True;
    end
  else
end;

function _CopyFile(const src, dst: string; const srcSize: Int64): Boolean;
begin
  SetPrivilege('SeBackupPrivilege');
  SetPrivilege('SeRestorePrivilege');
  Result := (DC_CopyFileEx(src, dst) or CopyHive(src, dst, Opts)) and Touch(src, dst);
  UnSetPrivilege('SeBackupPrivilege');
  UnSetPrivilege('SeRestorePrivilege');
end;

function copyfile(const src, dst, reas: string; const sz: Int64): boolean;
begin
  Application.ProcessMessages;
  result := False;
  ForceDirectories(ExtractFilePath(dst));
  if _copyfile(src, dst, sz) then
  begin
    if (liCopying in Opts.oLogWhat)
      then
      LogError(Format(rsmcf, [src, dst, reas]), leSuccess);
    result := setattr(src, dst);
  end
  else
  begin
    // testen, ob noch genug platz auf der platte ist
    if DiskGetFree(ExtractFileDrive(dst)) < FileGetSize(src) then
    begin
      CheckError(Format(rsmns, [src, dst]), mtError, [mbCancel], 0);
      fEscape := True;
      Result := False;
      exit; //xxx111
    end
    else
    begin
      if fEscape
        then
        Exit;
      case CheckError(format(rsmsec, [src, dst, GetErrMsg])) of
        mrcancel:
          begin
            result := false;
            exit;
          end;
        mrretry:
          begin
            result := copyfile(src, dst, reas, sz);
            exit;
          end;
        mrignore:
          begin
            Result := True;
            exit;
          end;
      end;
    end;
  end;
end;

function delfile(const a: tfilename; const Silent: Boolean = False): boolean;
var
  le: Integer;
begin
  result := true;
  le := GetLastError;
  if not fileexists(a) then
  begin
    SetLastError(le);
    exit;
  end;
  filesetattr(a, 0);
  deletefile(PChar(a));
  if fileexists(a) then
  begin
    if Silent
      then
      Exit;
    case CheckError(Format(rsmsed, [a, GetErrMsg])) of
      mrcancel:
        begin
          result := false;
          exit;
        end;
      mrretry:
        begin
          SetLastError(le);
          result := delfile(a);
          exit;
        end;
    end;
  end
  else
    SetLastError(le);
end;


procedure InitMask(mask: string);
var
  ct: integer;
begin
  Ifilemask.clear;
  Ifilemask.sorted := false;
  Efilemask.clear;
  Efilemask.sorted := false;
  if mask = '' then
  begin
    Ifilemask.add('*');
    exit;
  end;
  for ct := 1 to Length(mask)
    do
    if mask[ct] = ';'
      then
      mask[ct] := ',';
  Ifilemask.CommaText := mask;
  // delete empty strings
  for ct := Pred(Ifilemask.Count) downto 0
    do
    if Trim(Ifilemask[ct]) = ''
      then
      Ifilemask.Delete(ct)
    else
      if IFileMask[ct][1] = '|' then
      begin
        EFileMask.Add(Copy(IFileMask[ct], 2, MaxInt));
        IFileMask.Delete(ct);
      end;
  // delete empty strings
  if EFileMask.Count > 0
    then
    for ct := Pred(Efilemask.Count) downto 0
      do
      if Trim(Efilemask[ct]) = ''
        then
        Efilemask.Delete(ct);
  if IFileMask.Text = ''
    then
    IFileMask.Add('*');
  Ifilemask.sorted := true;
  Ifilemask.duplicates := dupignore;
  Efilemask.sorted := true;
  Efilemask.duplicates := dupignore;
end;



function cmpmask1(a, b: string): boolean;
// tests whether the string 'a' matches the search mask in 'b'

var
  sr: string;
  dontcare: boolean;
  onechar: char;
  ctl, cts, fg, tp: integer;

begin
  a := AnsiLowerCase(a);
  b := AnsiLowerCase(b);
  Result := True;
  if b = '*'
    then
    exit; // always matches

  if (b = '*.*') and (Pos('.', a) > 0)
    then
    exit; // matches too

  if (pos('*', b) = 0) and (pos('?', b) = 0) then
  begin
    Result := a = b;
    exit;
  end;

  Result := False;
  if b = ''
    then
    exit;

  ftmplist.clear;

  // separate partial strings ('?','*' or text) to Ftmplist
  repeat
    onechar := b[1];
    if (onechar = '*') or (onechar = '?') then
    begin
      ftmplist.add(onechar);
      delete(b, 1, 1);
    end
    else
    begin
      tp := pos('?', b);
      if tp = 0
        then
        tp := maxint;

      fg := pos('*', b);

      if fg = 0
        then
        fg := maxint;

      if fg > tp
        then
        fg := tp;

      ftmplist.add(copy(b, 1, fg - 1));
      b := copy(b, fg, maxint);
    end;
  until b = '';

  // now compare the string with the partial search masks
  dontcare := false;
  cts := 1;
  if ftmplist.count = 0
    then
    exit;

  for ctl := 0 to pred(ftmplist.count) do
  begin
    sr := ftmplist[ctl];

    if sr <> ''
      then
      case sr[1] of
        '?': cts := cts + 1;
        '*': dontcare := true;
      else
        if dontcare then
        begin
          tp := pos(sr, copy(a, cts, maxint));
          dontcare := false;
          if tp = 0
            then
            break;

          cts := tp + length(sr) + cts - 1;
        end
        else
        begin
          if copy(a, cts, length(sr)) <> sr
            then
            break;

          cts := cts + length(sr);
        end;

      end;

  end;

  if (not dontcare) and (cts <> length(a) + 1)
    then
    exit;

  if ctl <> ftmplist.count
    then
    exit;

  result := true;
end;

function InMask(fname: string): boolean;
// tests whether the string 'a' matches the search masks in ffilemask

var
  ct: integer;
begin
  result := false;
  if (Ifilemask = nil) or (Ifilemask.count < 1)
    then
    exit;

  for ct := 0 to pred(Ifilemask.count) do
  begin
    if cmpmask1(fname, Ifilemask[ct]) then
    begin
      Result := True;
      break;
    end;
  end;

  if Result then
  begin
    if EFileMask.Count = 0
      then
      Exit;

    for ct := 0 to pred(Efilemask.count) do
    begin
      if (EFileMask[ct][1] <> '>') and cmpmask1(fname, Efilemask[ct]) then
      begin
        Result := False;
        break;
      end;
    end;
  end;

end;

function IsExcludedDir(fname: string): boolean;
var
  ct: integer;
begin
  result := false;
  if (Efilemask = nil) or (Efilemask.count < 1)
    then
    exit;

  for ct := 0 to pred(Efilemask.count) do
  begin
    if (EFileMask[ct][1] = '>') and cmpmask1(fname, Copy(Efilemask[ct], 2, MaxInt)) then
    begin
      Result := True;
      break;
    end;
  end;

end;

procedure SetSpecialStatusText(const msg, sep, par: string);
begin
  if not IsMinim
    then
    fmMain.StatusText := Format(msg, [sep + par])
  else
    SetAppTitle(Format(msg, [par]));
end;

function addcopies(const src, dst: string): boolean;
var datas, datat: WIN32_FIND_DATA;
  fres1, fres2: THandle;
  srn: string;
  DirList: TStringList;
begin
  Sleep(MS_SLEEP);
  DirList := TStringList.Create;
  try
    SetSpecialStatusText(rsmas, '[|]', src);

    result := true;

    application.processmessages;

    if fescape then
    begin
      result := false;
      exit;
    end;

    // berprfen, ob dest-directory existiert
    if (not MPDirectoryExists(dst)) then
    begin
      CheckAdd(CopyList, (NewFileRec(0, NullFileTime, src, 0,
        0, NullFileTime, dst, 0, arNewDir, 0)));
    end;

    // verzeichnis durchsuchen
    fres1 := FindFirstFile(PChar(DelBackSlash(src) + '\*.*'), datas);
    if fres1 <> INVALID_HANDLE_VALUE then
    begin
      repeat
        Sleep(MS_SLEEP);
        srn := StrPas(@datas.cFileName);
        // testen, ob directory
        if Bool(datas.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) then
        begin
          if Opts.oRecSubs and (srn <> '.') and (srn <> '..')
            then
            DirList.Add(srn);
        end
        else
        begin
          // datei
          if (not Bool(datas.dwFileAttributes and (FILE_ATTRIBUTE_DIRECTORY or $8))) and InMask(srn) then
          begin
            if not IsMinim
              then
              fmMain.StatusText := Format(rsmac, ['[|]' + src + srn]);
            Application.ProcessMessages;
            if fescape then
            begin
              Result := False;
              FindClose(fres1);
              exit;
            end;
            // Sourcedatei in Dest nicht enthalten
            fres2 := FindFirstFile(PChar(DelBackSlash(dst) + '\' + srn), datat);
            if fres2 = INVALID_HANDLE_VALUE
              then
              CheckAdd(CopyList, (NewFileRec(FSizeW32FD(datas), datas.ftLastWriteTime, DelBackSlash(src) + '\' + srn, 0,
                0, NullFileTime, DelBackSlash(dst) + '\' + srn, 0,
                arNewFile, 0)))
            else
            begin
              FindClose(fres2);
              //jetzt ueberpruefen, ob dstfile nicht neuer ist oder overwritenewerfiles
              if (not Opts.oNoNew) or (not IsFileNewer(datat.ftLastWriteTime, datas.ftLastWriteTime)) then
              begin
                // falls groessen  unterschiedlich sind
                if FSizeW32FD(datas) <> FSizeW32FD(datat)
                  then
                  CheckAdd(CopyList, (NewFileRec(FSizeW32FD(datas), datas.ftLastWriteTime, DelBackSlash(src) + '\' + srn, 0,
                    FSizeW32FD(datat), datat.ftLastWriteTime, DelBackSlash(dst) + '\' + srn, 0,
                    arSize, 0)))
                else
                // falls die Zeit unterschiedlich ist
                  if ( (not Opts.oNoTime) and DifferentFileTime(datas.ftLastWriteTime, datat.ftLastWriteTime) )
                    then
                    CheckAdd(CopyList, (NewFileRec(FSizeW32FD(datas), datas.ftLastWriteTime, DelBackSlash(src) + '\' + srn, 0,
                      FSizeW32FD(datat), datat.ftLastWriteTime, DelBackSlash(dst) + '\' + srn, 0,
                      arDate, 0)))
                  else
                    if (DifferentFileAttributes(datas.dwFileAttributes, datat.dwFileAttributes, Opts.oWhatIgA))
                      then
                      CheckAdd(CopyList, (NewFileRec(FSizeW32FD(datas), datas.ftLastWriteTime, DelBackSlash(src) + '\' + srn, datas.dwFileAttributes,
                        FSizeW32FD(datat), datat.ftLastWriteTime, DelBackSlash(dst) + '\' + srn, datat.dwFileAttributes,
                        arAttr, Opts.oWhatIgA)))
              end;
            end;
          end;
        end;
      until not FindNextFile(fres1, datas);
      FindClose(fres1);

      if DirList.Count > 0
        then
        for fRes1 := 0 to Pred(DirList.Count)
          do
          if (not IsExcludedDir(DirList[fres1])) and
            (not addcopies(src + DirList[fres1] + '\', dst + DirList[fres1] + '\')) then
          begin
            Result := False;
            exit;
          end;
    end;
  finally
    DirList.Free;
  end;
end;

function adddels(const src, dst: string): boolean;
var datas, datat: WIN32_FIND_DATA;
  fres1, fres2: THandle;
  srn: string;
  dirList: TStrings;
begin
  Sleep(MS_SLEEP);
  dirList := TStringList.Create;
  try
    SetSpecialStatusText(rsmas, '[|]', src);

    result := true;

    application.processmessages;

    if fescape then
    begin
      result := false;
      exit;
    end;

    // verzeichnis durchsuchen
    fres1 := FindFirstFile(PChar(DelBackSlash(src) + '\*.*'), datas);
    if fres1 <> INVALID_HANDLE_VALUE then
    begin
      repeat
        Sleep(MS_SLEEP);
        srn := StrPas(@datas.cFileName);
        // testen, ob directory
        if Bool(datas.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) then
        begin
          if (srn <> '.') and (srn <> '..')
            then
            DirList.Add(srn);
        end
        else
        begin
          // datei
          if not Bool(datas.dwFileAttributes and (FILE_ATTRIBUTE_DIRECTORY or $8)) then
          begin
            if not IsMinim
              then
              fmMain.StatusText := Format(rsmac, ['[|]' + src + srn]);
            Application.ProcessMessages;
            if fescape then
            begin
              Result := False;
              FindClose(fres1);
              exit;
            end;
            fres2 := FindFirstFile(PChar(DelBackSlash(dst) + '\' + srn), datat);
            if fres2 = INVALID_HANDLE_VALUE
              then
              CheckAdd(DelList, (NewFileRec(FSizeW32FD(datas), datas.ftLastWriteTime, DelBackSlash(src) + '\' + srn, 0,
                0, NullFileTime, DelBackSlash(dst) + '\' + srn, 0,
                arDelFile, 0)))
            else
              FindClose(fres2);
          end;
        end;
      until not FindNextFile(fres1, datas);
      FindClose(fres1);
    end;

    if DirList.Count > 0
      then
      for fRes1 := 0 to Pred(DirList.Count)
        do
        if not adddels(src + DirList[fres1] + '\', dst + DirList[fres1] + '\') then
        begin
          Result := False;
          exit;
        end;


    // berprfen, ob dest-directory existiert
    if (not MPDirectoryexists(dst)) then
    begin
      CheckAdd(DelList, (NewFileRec(0, NullFileTime, src, 0,
        0, NullFileTime, dst, 0, arDelDir, 0)));
    end;
  finally
    DirList.Free;
  end;
end;

function addtocopylist(const rec: boolean; const src, dst: string): boolean;
var
  oldsb: string;
begin
  oldsb := fmMain.StatusText;
  try
    Result := addcopies(src, dst);
  finally
    fmMain.StatusText := oldsb;
  end;
end;

function addtodellist(const src, dst: string): boolean;
var
  oldsb: string;
begin
  oldsb := fmMain.StatusText;
  try
    Result := adddels(src, dst);
  finally
    fmMain.StatusText := oldsb;
  end;
end;

function DelBackSlash(const str: string): string;
begin
  if (str <> '') and (str[Length(str)] = '\')
  then
    Result := Copy(str, 1, Length(str) - 1)
  else
    Result := str;
end;

function MPDelDir(const aPath: TFileName): Boolean;
begin
  if not MPDirectoryExists(aPath)
    then
    Result := True
  else
  begin
    filesetattr(DelBackSlash(aPath), FILE_ATTRIBUTE_DIRECTORY);
{$I-}
    rmDir(DelBackSlash(aPath));
{$I+}
    Result := not MPDirectoryExists(aPath);
    if not Result then
    begin
      Result := True;
      case CheckError(Format(rsmsedd, [aPath, GetErrMsg])) of
        mrcancel:
          begin
            result := false;
            exit;
          end;
        mrretry:
          begin
            result := MPDelDir(aPath);
            exit;
          end;
      end;
    end;
  end;
end;

function DelFileOrDirAndLog(const a: tfilename; const Reason: TActReason): Boolean;
begin
  Result := False;
  case Reason of
    arNewFile, arNewDir, arAttr, arSize, arDate: Halt(EN_INVDELFILE);
    arDelFile:
      begin
        Result := delfile(a);
        if Result and (liDeletion in Opts.oLogWhat)
          then
          LogError(Format(rsmdf, [a]), leSuccess);
      end;
    arDelDir:
      begin
        Result := MPDelDir(a);
        if Result and (liDeletion in Opts.oLogWhat)
          then
          LogError(Format(rsmdd, [a]), leSuccess);
      end;
  end;
end;

function MPBrowseCallbackProc(wnd: HWND; uMsg: Uint;
  alParam, lpData: LPARAM): Integer; stdcall;
var
  Buffer: array[0..Max_Path + 1] of Char;
begin
  case uMsg
    of
    BFFM_INITIALIZED: begin
        if (lpData <> -1)
          then
          SetWindowPos(wnd, HWND_TOP, lpData shr 16, lPData and 65535,
            0, 0, SWP_NOSIZE);
        if gFirst <> nil
          then
          SendMessage(wnd, BFFM_SETSELECTION, 0, LPARAM(gFirst));
      end;

    BFFM_SELCHANGED: begin
        if alParam <> 0 then
        begin
          SHGetPathFromIDList(PItemIDList(alParam), Buffer);
          if not MPDirectoryExists(StrPas(Buffer))
            then
            SendMessage(wnd, BFFM_ENABLEOK, 0, 0)
          else
            SendMessage(wnd, BFFM_ENABLEOK, 1, 1);
        end;
      end;

  end;
  Result := 0;
end;


//* select a directory *//

function MPSelectDirectory(const Caption: string; const FirstSelection: WideString;
  const aLeft, aTop: Integer;
  out Directory: string): Boolean;

var
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  Eaten, Flags: LongWord;
const
  Root: string = 'Desktop';
begin
  Result := False;
  Directory := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      gDesktopFolder.ParseDisplayName(Application.Handle, nil,
        POleStr(WideString(Root)), Eaten, RootItemIDList, Flags);
      gFirst := nil;
      gDesktopFolder.ParseDisplayName(Application.Handle, nil,
        POleStr(FirstSelection), Eaten, gFirst, Flags);
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := PChar(Caption);
        ulFlags := BIF_RETURNONLYFSDIRS;
        lpfn := MPBrowseCallBackProc;
        lParam := -1;
        if (aLeft <> -1) or (aTop <> -1)
          then
          lParam := LongInt((aLeft shl 16) + (aTop and 65535));
      end;
      ItemIDList := ShBrowseForFolder(BrowseInfo);
      Result := ItemIDList <> nil;
      if Result then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        Directory := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
      if gFirst <> nil
        then
        ShellMalloc.Free(gFirst);
    end;
  end;
end;

function CheckError(ErrMsg: string; (*const ThisLog : TLogInclude = liError;*) const MType: TMsgDlgType = mtWarning;
  const Buttons: TMsgDlgButtons = [mbCancel, mbRetry, mbIgnore]; const HCTX: Integer = 0): Word;
begin
  if Opts.oLogWhat <> [] then
  begin
    if (liError in Opts.oLogWhat) //xxx11
      then
      LogError(ErrMsg, leError);
    Result := mrIgnore;
    ActionResult := adFailed;
    WasError := True;
  end
  else
  begin
    SetForeGroundWindow(Application.Handle);
    if (Pos('e#', ErrMsg) = 1) or (Pos('w#', ErrMsg) = 1)
      then
      Delete(ErrMsg, 1, 2);
    Result := messagedlg(ErrMsg, MType, Buttons, HCTX);
    case Result of
      mrIgnore: ActionResult := adFailed;
      mrRetry: ActionResult := adToDo;
      mrCancel: ActionResult := adFailed;
    end;
  end;
end;

procedure TfmMain.CalcSizes;
var
  ct: Integer;
begin
  ByteCount := 0;
  ByteCountCur := 0;
  FileCount := 0;
  FileCountLeft := 0;
  FileCountCur := 0;
  CopyList.Pack;
  DelList.Pack;
  if CopyList.Count > 0
    then
    for ct := 0 to Pred(CopyList.Count)
      do
      if Assigned(CopyList[ct])
        then
        with TFileRec(CopyList[ct]^) do
        begin
          Inc(FileCount);
          if IsDone = adToDo
            then
            Inc(FileCountLeft);
          Inc(ByteCount, Size_Src);
          if IsDone <> adToDo then
          begin
            Inc(FileCountCur);
            Inc(ByteCountCur, Size_Src);
          end;
        end;
  if DelList.Count > 0
    then
    for ct := 0 to Pred(DelList.Count)
      do
      if Assigned(DelList[ct])
        then
        with TFileRec(DelList[ct]^) do
        begin
          Inc(FileCount);
          if IsDone = adToDo
            then
            Inc(FileCountLeft);
          Inc(ByteCount, Size_Src);
          if IsDone <> adToDo then
          begin
            Inc(FileCountCur);
            Inc(ByteCountCur, Size_Src);
          end;
        end;
  Hint := Format(rmlc, [Readable(FileCount), Readable(ByteCount)]);
end;
// form

procedure TfmMain.FormCreate(Sender: TObject);
begin
  FFirst := True;
  Application.OnHint := FormHint;
  Application.OnMinimize := FormMin;
  Application.OnRestore := FormRest;
  copylist := tlist.create;
  dellist := tlist.create;
  OptsToGUI(Opts);
  acDo.Enabled := False;
  acShow.Enabled := False;
  Caption := defcap;
end;

procedure TfmMain.FormDestroy(Sender: TObject);
begin
  if TaskIcon
    then
    DestroyTaskIcon;
  clearlist(copylist);
  clearlist(dellist);
  copylist.free;
  dellist.free;
end;

// v1.7

function tfmMain.buildlist: boolean;
var
  srcp, dstp, mask: string;
  act: Integer;
begin
  screen.cursor := crhourglass;
  result := true;
  try
    clearlist(copylist);
    clearlist(dellist);
    GUIToOpts(Opts, Opts.oLogName, Opts.oLogWhat, Opts.oEventLog);

    // testen, ob check-file vorhanden
    if (Opts.oCheckFile <> '') and (not FileExists(Opts.oCheckFile)) then
    begin
      if (Opts.oAuto and Opts.oClose) then
      begin
        LogStart;
        LogError(Format(emfnc, [Opts.oCheckFile]), leError);
        SetLastError(EN_CHECKFILE);
        MinimHalt(EN_CHECKFILE);
      end
      else
      begin
        MsgFehler(Format(emfnc, [Opts.oCheckFile]));
        Result := False;
        MinimHalt(EN_CHECKFILE);
      end;
    end;
    act := 0;
    while act < Opts.oDirList.Count do
    begin
      if lvFList.Items.Count > (act div 2)
        then
        lvFList.Selected := lvFList.Items[act div 2];
      srcp := ExtractFileMaskandDir(Opts.oDirList[act], mask);
      if not MPDirectoryExists(srcp) then
      begin
        Fehler(Format(rmednf, [srcp]));
        Result := False;
        Exit;
      end;
      inc(act, 2);
    end;
    act := 0;
    while act < Opts.oDirList.Count do
    begin
      if lvFList.Items.Count > (act div 2)
        then
        lvFList.Selected := lvFList.Items[act div 2];
      srcp := ExtractFileMaskandDir(Opts.oDirList[act], mask);
      InitMask(mask);
      dstp := DelBackSlash(Opts.oDirList[act + 1]);
      Inc(act, 2);
      if not MPDirectoryExists(srcp) then
      begin
        Fehler(Format(rmednf, [srcp]));
        Result := False;
        Exit;
      end;
      // copylist bilden
      srcp := srcp + '\';
      dstp := dstp + '\';
      if not addtocopylist(Opts.oRecSubs, srcp, dstp) then
      begin
        fehler(rmeoa);
        _Aborted := True;
        result := false;
        exit;
      end;
      if Opts.oDel
        then
        if not addtodellist(dstp, srcp) then
        begin
          fehler(rmeoa);
          _Aborted := True;
          result := false;
          exit;
        end;
    end;
    if Opts.oNoEDir
      then
      DeleteEmptyDirs;
    if (Opts.oCheckFile <> '')
      then
      DeleteCheckFileFromDelList;
  finally
    StatusText := '';
    SetAppTitle(defCap);
    if Result
      then
      CalcSizes;
    screen.cursor := crdefault;
  end;
end;

procedure TfmMain.CBRecurseClick(Sender: TObject);
begin
  NonPossibile;
end;

procedure TfmMain.do_click;
begin
  CalcSizes;
  GUIToOpts(Opts, Opts.oLogName, Opts.oLogWhat, Opts.oEventLog);
  DisableControls;
  if Opts.oLogWhat <> []
    then
    LogStart;
  fescape := false;
  WasError := False;
  if not Opts.oAuto then
  begin
    if Bool(DelList.Count) then
    begin
      case messagedlg(rsmcdel, mtWarning, [mbYes, mbAbort], 0) of
        idAbort:
          begin
            EnableControls;
            Abort;
          end;
      end;
    end;
    with TdlgProg.Create(Application) do
    try
      lbFilesTot.Caption := Readable(FileCount);
      lbBytesTot.Caption := Readable(ByteCount);
      UpdateBarForm := BarsUpdate;
      ShowModal;
    finally
      Free;
      UpdateBarForm := nil;
      if ((liError in Opts.oLogWhat) and WasError and (not fEscape)) then
      begin
        if LoggedTo = ltEventLog then
        begin
          if MessageDlg(rmeocev, mtWarning, [mbYes, mbNo], 0) = idYes
            then
            WinExec('eventvwr.exe', SW_SHOW);
        end
        else
        begin
          if MessageDlg(Format(rmeoc, [Opts.oLogName]), mtWarning, [mbYes, mbNo], 0) = idYes
            then
            ShellExecute(0, 'open', 'notepad.exe', PChar('"' + Opts.oLogName + '"'), nil, SW_SHOW);
        end;
      end;
    end
  end
  else
  begin
    DoCopying;
  end;
  WasError := False;
end;

procedure TfmMain.DisableControls;
var
  ct: Integer;
begin
  UpdateButtons;
  // alles bis auf exit disablen ( edits grau schalten )
  for ct := 0 to Pred(ComponentCount) do
  begin
    if Components[ct] is TSpeedButton
      then
      TSpeedButton(Components[ct]).Enabled := False
    else
      if (Components[ct] is TListView) then
      begin
        TListView(Components[ct]).Enabled := False;
        TListView(Components[ct]).Color := clBtnFace;
        TListView(Components[ct]).Selected := nil;
        TListView(Components[ct]).ItemFocused := nil;
      end
      else
        if (Components[ct] is TControl) and (Components[ct] <> ToolBar1) and (Components[ct] <> CoolBar1)
          then
          TControl(Components[ct]).Enabled := False
        else
          if (Components[ct] is TAction)
            then
            TAction(Components[ct]).Enabled := False;
  end;
  acCancel.Enabled := TestAction(acCancel);
  ToolButton15.Action := acCancel;
  (*ToolButton11.Enabled := False;
  ToolButton11.Visible := False;
  SpeedButton1.Enabled := True;
  SpeedButton1.Visible := True;*)
  Exit1.Action := acCancel;

end;

procedure TfmMain.EnableControls;
var
  ct: Integer;
begin
  for ct := 0 to Pred(ComponentCount) do
  begin
    if Components[ct] is TSpeedButton
      then
      TSpeedButton(Components[ct]).Enabled := True
    else
      if (Components[ct] is TListView) then
      begin
        TListView(Components[ct]).Enabled := True;
        TListView(Components[ct]).Color := clWindow;
      end
      else
        if (Components[ct] is TControl) and (Components[ct] <> ToolBar1) and (Components[ct] <> CoolBar1)
          then
          TControl(Components[ct]).Enabled := True
        else
          if (Components[ct] is TAction)
            then
            TAction(Components[ct]).Enabled := TestAction(TAction(Components[ct]));
  end;
  acExit.Enabled := TestAction(acExit);
  ToolButton15.Action := acExit;
  (*ToolButton11.Enabled := True;
  ToolButton11.Visible := True;
  SpeedButton1.Enabled := False;
  SpeedButton1.Visible := False;*)
  Exit1.Action := acExit;
  acLogging.Enabled := RBLog.Checked and TestAction(acLogging);
  UpdateButtons;
  CBForceReg.Enabled := IsNT and cbDel.Enabled;
end;

procedure TfmMain.FormHint(Sender: TObject);
begin
  StatusText := Application.Hint;
end;

procedure TfmMain.FormActivate(Sender: TObject);
begin
  if fFirst then
  begin
    FormPosLoad(self);
    UpdateButtons;
    if Opts.oAuto then
    begin
      Application.Minimize;
      ShowWindow(Application.Handle, SW_HIDE);
      PostMessage(Handle, WM_PERFORMAUTO, 88, 99);
    end
    else
      ShowWindow(Application.Handle, SW_SHOW);
  end;
  fFirst := False;
end;

procedure TfmMain.WMPERFORMAUTO(var msg: TMessage);
begin
  if (msg.lParam = 99) and (msg.WParam = 88) then
  begin
    if not acBuild.Enabled then
    begin
      if Opts.oLogWhat <> [] then
      begin
        LogStart;
        LogError(rsmefbl, leError);
        HaltTaskIcon;
      end;
      if Opts.oClose
        then
        Close
      else
        if IsMinim
          then
          Application.Restore
    end
    else
    begin
      NothingToDo := False;
      Build_Click;
      if not acDo.Enabled then
      begin
        if NothingToDo then
        begin
          LogStart;
          LogError(rsmnotd, leInfo);
          HaltTaskIcon;
          if (not fEscape) and (Opts.oRunFin <> '') then
          begin
            PostMessage(Handle, WM_RUNAFTER, 17, 4);
          end;
        end
        else
        begin
          if Opts.oLogWhat <> [] then
          begin
            LogStart;
            LogError(rsmefco, leError);
            HaltTaskIcon;
          end;
        end;
        if Opts.oClose
          then
          Close
        else
          HaltTaskIcon;
      end
      else
      begin
        Do_Click;
        if Opts.oClose
          then
          Close
        else
          HaltTaskIcon;
      end;
    end;
  end;
end;

procedure TfmMain.FormMin(Sender: TObject);
begin
  IsMinim := True;
  if Opts.oAuto
    then
    CreateTaskIcon;
  SetAppTitle(defCap);
end;

procedure TfmMain.FormRest(Sender: TObject);
begin
  IsMinim := False;
  if TaskIcon
    then
    DestroyTaskIcon;
  SetAppTitle(defCap);
  StatusText := defCap;
end;

function TfmMain.MakeParams: string;

  function _param(const Val: Boolean; const sr: string): string;
  begin
    Result := sr + ' ';
    if not Val
      then
      Result := 'no' + result;
    Result := '/' + result;
  end;

var
  ct: Integer;
  Opt1: TDCOptions;
begin
  Result := '';
  Opt1.oDirList := nil;
  InitOpts(Opt1);
  try
    GUIToOpts(Opt1, Opts.oLogName, Opts.oLogWhat, Opts.oEventLog);
    if Opt1.oLogWhat = []
      then
      Result := Result + '/confirm '
    else
      Result := Result + Result + Format('/log /lf:%s /lm:%s ', ['"' + Opt1.oLogName + '"', SetToStr(Opt1.oLogWhat)]);
    Result := Result + _param(Opt1.oAuto, 'auto');
    Result := Result + _param(Opt1.oDel, 'del');
    Result := Result + _param(Opt1.oRecSubs, 'recurse');
    Result := Result + _param(not Opt1.oNoNew, 'newfiles');
    Result := Result + _param(Opt1.oClose, 'close');
    if Opt1.oWhatIga <> 0
      then
      Result := Result + Format('/igattr:%s ', [FAttrToStr(Opt1.oWhatIgA)]);
    if Opt1.oCheckFile <> ''
      then
      Result := Result + Format('/checkfile:"%s" ', [Opt1.oCheckFile]);
    if Opt1.oRunFin <> ''
      then
      Result := Result + Format('/runafter:"%s" ', [Opt1.oRunFin]);
    Result := Result + _param(not Opt1.oNoEDir, 'emptydirs');
    if IsNT then
    begin
      Result := Result + _param(Opt1.oEventLog and RegisterEventLogApp, 'eventlog');
      Result := Result + _param(Opt1.oForceReg, 'forcereg');
    end;
    if Opt1.oDirList.Count > 0
      then
      for ct := 0 to Pred(Opt1.oDirList.Count) do
      begin
        Result := Result + '"' + Opt1.oDirList[ct] + '" ';
      end;
  finally
    ClearOpts(Opt1);
  end;
end;

procedure TfmMain.RBConfirmClick(Sender: TObject);
begin
  acLogging.Enabled := False;
end;

procedure TfmMain.RBLogClick(Sender: TObject);
begin
  acLogging.Enabled := TestAction(acLogging);
end;

procedure TfmMain.OptsToGui(Opts: TDCOptions);
var
  ct: Integer;
  sr: string;
begin
  lvFList.Items.Clear;
  if Opts.oDirList.Count > 0 then
  begin
    while Bool(Opts.oDirList.Count mod 2)
      do
      Opts.oDirList.Add('');
    ct := 0;
    while ct < (Opts.oDirList.Count) do
    begin
      with lvFList.Items.Add do
      begin
        Caption := ExtractFileMaskAndDir(Opts.oDirList[ct], sr);
        SubItems.Add(sr);
        SubItems.Add(Opts.oDirList[ct + 1]);
      end;
      Inc(ct, 2);
    end;
    if lvFList.Items.Count > 0 then
    begin
      lvFList.Selected := lvFList.Items[0];
      lvFList.ItemFocused := lvFList.Items[0];
    end;
    UpdateButtons;
  end;
  CBDel.Checked := Opts.oDel;
  CBRecurse.Checked := Opts.oRecSubs;
  CBNoNew.Checked := Opts.oNoNew;
  CBNoTime.Checked := Opts.oNoTime;
  CBSetTime.Checked := Opts.oSetTime;
  CBStartCopy.Checked := Opts.oStartCopy;
  edRunFileName.Text := Opts.oRunFin;
  edCheckFileName.Text := Opts.oCheckFile;
  cbNoEDir.Checked := Opts.oNoEDir;
  CBForceReg.Checked := Opts.oForceReg and IsNT;
  RBConfirm.Checked := False;
  RBLog.Checked := False;
  CBAttrA.Checked := Bool(Opts.oWhatIgA and FILE_ATTRIBUTE_ARCHIVE);
  CBAttrS.Checked := Bool(Opts.oWhatIgA and FILE_ATTRIBUTE_SYSTEM);
  CBAttrR.Checked := Bool(Opts.oWhatIgA and FILE_ATTRIBUTE_READONLY);
  CBAttrH.Checked := Bool(Opts.oWhatIgA and FILE_ATTRIBUTE_HIDDEN);
  if Opts.oLogWhat = []
    then
    RBConfirm.Checked := True
  else
    RBLog.Checked := True;
  aclogging.Enabled := TestAction(acLogging) and (Opts.oLogWhat <> []);

end;

procedure TfmMain.GUIToOpts(var FOpts: TDCOptions; const LogFile: string;
  const LogLevel: TWhatToLog; const ToEventLog: Boolean);
var
  ct: Integer;
begin
  FOpts.oDirList.Clear;
  if lvFList.Items.Count > 0
    then
    for ct := 0 to Pred(lvFList.Items.Count) do
    begin
      FOpts.oDirList.Add(DelBackSlash(lvFList.Items[ct].Caption) + '\' + lvFList.Items[ct].SubItems[0]);
      FOpts.oDirList.Add(lvFList.Items[ct].SubItems[1]);
    end;
  FOpts.oDel := CBDel.Checked;
  FOpts.oRecSubs := CBRecurse.Checked;
  FOpts.oForceReg := CBForceReg.Checked and IsNT;
  FOpts.oNoNew := CBNoNew.Checked;
  FOpts.oNoTime := CBNoTime.Checked;
  FOpts.oSetTime := CBSetTime.Checked;
  FOpts.oStartCopy := CBStartCopy.Checked;
  FOpts.oRunFin := edRunFileName.Text;
  FOpts.oCheckFile := edCheckFileName.Text;
  FOpts.oNoEDir := CBNoEDir.Checked;
  if RBConfirm.Checked
    then
    FOpts.oLogWhat := []
  else
    FOpts.oLogWhat := LogLevel;
  if RBLog.Checked and (FOpts.oLogWhat = [])
    then
    FOpts.oLogWhat := [liError];
  FOpts.oLogName := LogFile;
  FOpts.oEventLog := ToEventLog;
  FOpts.oAuto := Opts.oAuto;
  FOpts.oClose := Opts.oClose;
  FOpts.oWhatIgA := 0;
  if CBAttrA.Checked
    then
    FOpts.oWhatIgA := FOpts.oWhatIgA or FILE_ATTRIBUTE_ARCHIVE;
  if CBAttrS.Checked
    then
    FOpts.oWhatIgA := FOpts.oWhatIgA or FILE_ATTRIBUTE_SYSTEM;
  if CBAttrR.Checked
    then
    FOpts.oWhatIgA := FOpts.oWhatIgA or FILE_ATTRIBUTE_READONLY;
  if CBAttrH.Checked
    then
    FOpts.oWhatIgA := FOpts.oWhatIgA or FILE_ATTRIBUTE_HIDDEN;
end;

procedure TfmMain.PrintStatus(const typ: TStatusType; const path: string);
const
  cps: array[TStatusType] of string = (rsmWri, rsmEra);
begin
  Sleep(MS_SLEEP);
  if isMinim
    then
    SetAppTitle(GetPerCent(rsmFiles, FileCountCur, FileCount) + ' ' +
      GetPercent(rsmBytes, ByteCountCur, ByteCount) + ' ' +
      Format(cps[typ], [path]))
  else
  begin
    StatusText := Format(cps[typ], ['[|]' + path]);
    if Assigned(UpdateBarForm)
      then
      UpdateBarForm(ByteCountCur, TryPercent(ByteCountCur, ByteCount),
        FileCountCur, TryPercent(FileCountCur, FileCount), path);
  end;
end;

procedure TfmMain.DoCopying;
var
  ct: integer;
begin
  ActionResult := adToDo;
  try
    screen.cursor := crhourglass;
    // zuerst alle dateien kopieren
    if dellist.count > 0
      then
      for ct := 0 to Pred(dellist.count) do
      begin
        application.processmessages;
        if Assigned(dellist[ct])
          then
          with tfilerec(dellist[ct]^) do
          begin
            if fescape
              then
              exit;
            if IsDone = adToDo then
            begin
              PrintStatus(stDel, Name_Src);
              ActionResult := adSuccess;
              case Reason of
                arNewFile, arNewDir,
                  arAttr,
                  arSize,
                  arDate: Halt(EN_INVDELLIST);
                arDelFile, arDelDir: begin
                    sleep(MS_SLEEP);
                    if not DelFileOrDirAndLog(name_src, Reason)
                      then
                      exit
                    else
                      IsDone := ActionResult;
                  end;
              end;
              Inc(FileCountCur);
              Inc(ByteCountCur, Size_Src);
            end;
          end;
      end;

    if copylist.count > 0
      then
      for ct := 0 to Pred(copylist.count) do
      begin
        application.processmessages;
        if Assigned(copylist[ct])
          then
          with tfilerec(copylist[ct]^) do
          begin
            if fescape
              then
              exit;
            if IsDone = adToDo then
            begin
              ActionResult := adSuccess;
              PrintStatus(stCopy, name_dst);
              // zuerst berprfen, ob directory kopiert werden soll
              case Reason of
                arNewFile:
                  if not copyfile(name_src, name_dst, rsmrsNewDest, size_src)
                    then
                    exit
                  else
                    IsDone := ActionResult;
                arNewDir:
                  begin
                    ForceDirectories(name_dst);
                    IsDone := ActionResult;
                  end;
                arDelFile,
                  arDelDir: Halt(EN_INVCPLIST);
                arAttr:
                  if not setattr(name_dst, DiffAttr)
                    then
                    exit
                  else
                    IsDone := ActionResult;
                arSize,
                  arDate:
                  if not copyfile(name_src, name_dst, rsmrsChanged, size_src)
                    then
                    exit
                  else
                    IsDone := ActionResult;
              end;
              Inc(FileCountCur);
              Inc(ByteCountCur, Size_Src);
            end;
          end;
      end;
  finally
    StatusText := rsmrsReady;
    SetAppTitle(defCap);
    screen.cursor := crdefault;
    EnableControls;
    acDo.enabled := fEscape and TestAction(acDo);
    DoCont := fEscape;
    ActionResult := adToDo;
    if (not fEscape) and (Opts.oRunFin <> '') then
    begin
      PostMessage(Handle, WM_RUNAFTER, 17, 4);
    end;
    fescape := false;
  end;

end;

procedure TfmMain.acOpenSetExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  with OpenDialog1 do
  try
    Filter := rsmfConf;
    Title := rsmtConf;
    DefaultExt := 'CFG';
    FileName := '';
    if Execute then
    begin
      GetParamsFromControlFile(FileName, True);
    end;
  finally
  end;
end;

procedure TfmMain.acSaveSetExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  with SaveDialog1 do
  try
    Options := Options - [ofNoDereferenceLinks];
    Filter := rsmfConf;
    Title := rsmtScnf;
    DefaultExt := 'CFG';
    FileName := '';
    if Execute
      then
      StoreParamsInControlFile(FileName);
  finally
  end;
end;

procedure TfmMain.Build_click;
begin
  GUIToOpts(Opts, Opts.oLogName, Opts.oLogWhat, Opts.oEventLog);
  DoCont := False;
  DisableControls;
  fescape := false;
  NothingToDo := False;
  if not buildlist then
  begin
    Opts.oAuto := False;
    Opts.oClose := False;
    EnableControls;
    if not _Aborted
      then
      fehler(rsmebl)
    else
      fehler('');
    _Aborted := False;
    if IsMinim
      then
      Application.Restore;
    Exit;
  end;
  EnableControls;
  if IsMinim and (not Opts.oAuto)
    then
    Application.Restore;
  acShow.enabled := (copylist.count + dellist.count > 0) and TestAction(acShow);
  acDo.enabled := acShow.enabled and TestAction(acDo);
  NothingToDo := not Bool(copylist.Count + dellist.count);
  if Opts.oAuto
    then
    Application.Minimize;
end;

procedure TfmMain.lvFListChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  UpdateButtons;
end;

procedure TfmMain.UpdateButtons;
begin
  alMain.UpdateAction(nil);
end;

procedure TfmMain.lvFListClick(Sender: TObject);
begin
  UpdateButtons;
end;

procedure TfmMain.lvFListSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  UpdateButtons;
end;



var
  oldsort: Integer;
  n: Boolean;

function mysortlv(lParam1, lParam2, lParamSort: Integer): Integer stdcall;
var
  s1, s2: string;
begin
  if OldSort = lParamSort
    then
    n := not n
  else
    n := False;
  OldSort := lParamSort;
  if lParamSort = 0 then
  begin
    s1 := TListItem(lParam1).Caption;
    s2 := TListItem(lParam2).Caption;
  end
  else
  begin
    s1 := TListItem(lParam1).SubItems[lParamSort - 1];
    s2 := TListItem(lParam2).SubItems[lParamSort - 1];
  end;
  Result := lstrcmpi(PChar(s1), PChar(s2));
  if n
    then
    Result := -Result;

end;

procedure TfmMain.lvFListColumnClick(Sender: TObject; Column: TListColumn);
begin
  lvFList.CustomSort(@mysortlv, Column.Index);
end;


procedure TfmMain.acBuildExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  NothingToDo := False;
  Build_click;
  if NothingToDo and (not (Opts.oAuto or Opts.oClose))
    then
    MessageDlg(rsmnotd, mtInformation, [mbOK], 0)
  else
    begin
      if Opts.oStartCopy then
        do_click;
    end
end;

procedure TfmMain.acShowExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  with TDlgList.Create(Application) do
  try
    if showmodal = idok then
    begin
      copylist.pack;
      dellist.pack;
      CalcSizes;
      acShow.Enabled := Bool(FileCount) and TestAction(acShow);
      acDo.Enabled := Bool(FileCountLeft) and TestAction(acDo);
    end
    else
    begin
      acShow.enabled := false;
      acDo.enabled := false;
    end;
  finally
    Free;
  end;

end;

procedure TfmMain.acDoExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  do_click;
end;

procedure TfmMain.acExitExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  close;
end;

procedure TfmMain.acUpExecute(Sender: TObject);
var
  sr1, sr2, sr3: string;
  s: Integer;
begin
  if (Assigned(lvFList.Selected)) and (lvFList.Selected.Index > 0)
    then
    with lvFList do
    begin
      s := Selected.Index;
      sr1 := Items[s - 1].Caption;
      sr2 := Items[s - 1].SubItems[0];
      sr3 := Items[s - 1].SubItems[1];
      Items[s - 1].Caption := Selected.Caption;
      Items[s - 1].SubItems[0] := Selected.SubItems[0];
      Items[s - 1].SubItems[1] := Selected.SubItems[1];
      Selected.Caption := sr1;
      Selected.SubItems[0] := sr2;
      Selected.SubItems[1] := sr3;
      Selected := Items[s - 1];
      ItemFocused := Items[s - 1];
      UpdateButtons;
    end;
end;

procedure TfmMain.acDownExecute(Sender: TObject);
var
  sr1, sr2, sr3: string;
  s: Integer;
begin
  if (Assigned(lvFList.Selected)) and (lvFList.Selected.Index < Pred(lvFList.Items.Count))
    then
    with lvFList do
    begin
      s := Selected.Index;
      sr1 := Items[s + 1].Caption;
      sr2 := Items[s + 1].SubItems[0];
      sr3 := Items[s + 1].SubItems[1];
      Items[s + 1].Caption := Selected.Caption;
      Items[s + 1].SubItems[0] := Selected.SubItems[0];
      Items[s + 1].SubItems[1] := Selected.SubItems[1];
      Selected.Caption := sr1;
      Selected.SubItems[0] := sr2;
      Selected.SubItems[1] := sr3;
      Selected := Items[s + 1];
      ItemFocused := Items[s + 1];
      UpdateButtons;
    end;
end;

procedure TfmMain.acNewExecute(Sender: TObject);
var
  lv: TListItem;
begin
  lv := lvFList.Items.Add;
  with lv do
  begin
    Caption := rsmdsrc;
    SubItems.Add('*');
    SubItems.Add(rsmdtrg);
  end;
  lvFList.ItemFocused := lv;
  lvFList.Selected := lv;
  ClearList(CopyList);
  ClearList(DelList);
  CalcSizes;
  Fehler('');
  acprop.Execute;
end;

procedure TfmMain.acDelExecute(Sender: TObject);
var
  i: Integer;
begin
  if (lvFList.Items.Count > 0) and (Assigned(lvFList.Selected)) then
  begin
    i := lvFList.Selected.Index;
    lvFList.Items.Delete(i);
    while i >= lvFList.Items.Count
      do
      Dec(i);
    lvFList.Selected := lvFList.Items[i];
    lvFList.ItemFocused := lvFList.Items[i];
    ClearList(CopyList);
    ClearList(DelList);
    CalcSizes;
    Fehler('');
    UpdateButtons;
  end;
end;

procedure TfmMain.acpropExecute(Sender: TObject);
begin
  if Assigned(lvFList.Selected) then
  begin
    with TdlgMod.Create(Application) do
    try
      edSrc.Text := lvFList.Selected.Caption;
      edMask.Text := lvFList.Selected.SubItems[0];
      edTrg.Text := lvFList.Selected.SubItems[1];
      if ShowModal = IDOK then
      begin
        ClearList(CopyList);
        ClearList(DelList);
        CalcSizes;
        Fehler('');
        lvFList.Selected.Caption := edSrc.Text;
        if edMask.Text = ''
          then
          lvFList.Selected.SubItems[0] := '*'
        else
          lvFList.Selected.SubItems[0] := edMask.Text;

        lvFList.Selected.SubItems[1] := edTrg.Text;
      end
      else
        if (lvFList.Selected.Caption + lvFList.Selected.SubItems[1]) = rsmdsrc + rsmdtrg
          then
          acDel.Execute;
      if Assigned(lvFList.Selected) then
        if (lvFList.Selected.Caption + lvFList.Selected.SubItems[1]) = ''
          then
          acDel.Execute;
    finally
      Free;
    end;
  end;
end;

procedure TfmMain.acLoggingExecute(Sender: TObject);
begin
  GUIToOpts(Opts, Opts.oLogName, Opts.oLogWhat, Opts.oEventLog);
  with TdlgLog.Create(Application) do
  try
    cbLogCP.Checked := liCopying in Opts.oLogWhat;
    cbLogDel.Checked := liDeletion in Opts.oLogWhat;
    cbLogErr.Checked := liError in Opts.oLogWhat;
    edLogFileName.Text := Opts.oLogName;
    cbEventLog.Checked := Opts.oEventLog;
    if ShowModal = mrOK then
    begin
      Opts.oLogWhat := [];
      if cbLogErr.Checked
        then
        Include(Opts.oLogWhat, liError);
      if cbLogCP.Checked
        then
        Include(Opts.oLogWhat, liCopying);
      if cbLogDel.Checked
        then
        Include(Opts.oLogWhat, liDeletion);
      Opts.oLogName := edLogFileName.Text;
      Opts.oEventLog := cbEventLog.Checked;
    end;
  finally
    Free;
  end;
end;

procedure TfmMain.alMainUpdate(Action: TBasicAction; var Handled: Boolean);
begin
  acup.Enabled := ((lvFList.Items.Count > 1) and Assigned(lvFList.Selected) and
    (lvFList.Selected.Index > 0)) and TestAction(acUp) and lvFList.Enabled;

  acdown.Enabled := ((lvFList.Items.Count > 1) and Assigned(lvFList.Selected) and
    (lvFList.Selected.Index < Pred(lvFList.Items.Count))) and TestAction(acDown) and lvFList.Enabled;

  acNew.Enabled := (lvFList.Enabled) and TestAction(acNew) and lvFList.Enabled;
  acDel.Enabled := (lvFList.Items.Count > 0) and Assigned(lvFList.Selected) and TestAction(acDel) and lvFList.Enabled;
  acprop.Enabled := ((lvFList.Items.Count > 0) and Assigned(lvFList.Selected)) and TestAction(acProp) and lvFList.Enabled;
  acDuplicate.Enabled := ((lvFList.Items.Count > 0) and Assigned(lvFList.Selected)) and TestAction(acDuplicate) and lvFList.Enabled;
  acSwapAll.Enabled := (lvFList.Items.Count > 0) and TestAction(acSwapAll) and lvFList.Enabled;

  acBuild.Enabled := (lvFList.Items.Count > 0) and TestAction(acBuild) and lvFList.Enabled;
  CBForceReg.Enabled := IsNT and cbDel.Enabled;
  if DoCont then
  begin
    acDo.Caption := rsmfcont;
    acDo.Hint := rsmfContH;
  end
  else
  begin
    acDo.Caption := rsmfDo;
    acDo.Hint := rsmfDoH;
  end;
end;


procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  fEscape := True;
end;

procedure TfmMain.NonPossibile;
begin
  ClearList(CopyList);
  ClearList(DelList);
  CalcSizes;
  acShow.Enabled := False;
  acDo.Enabled := False;
end;

procedure TfmMain.acCancelExecute(Sender: TObject);
begin
  Opts.oClose := False;
  Opts.oAuto := False;
  fescape := true
end;

function TfmMain.GetStatusText: string;
begin
  Result := StatusBar1.SimpleText;
end;

procedure TfmMain.SetStatusText(const Text: string);
var
  s: Integer;
  sr: string;
begin
  sr := Trim(Text);
  s := Pos('[|]', sr);
  if s > 0 then
  begin
    StatusBar1.SimpleText := ' ' + Copy(sr, 1, s - 1) + Copy(sr, s + 3, MaxInt);
  end
  else
  begin
    StatusBar1.SimpleText := ' ' + sr;
  end;
  StatusBar1.Update;
end;

procedure TfmMain.DeleteEmptyDirs;

  function HasKids(const sr: string): Boolean;
  var
    i: Integer;
  begin
    Result := False;
    for i := Pred(CopyList.Count) downto 0 do
    begin
      if Assigned(CopyList[i])
        then
        with TFileRec(CopyList[i]^)
          do
          if (Length(Name_Src) > Length(sr)) and (Pos(sr, AnsiLowerCase(Name_Src)) = 1) then
          begin
            Result := True;
            Break;
          end;
    end;
  end;

var
  done: Boolean;
  i: Integer;
begin
  done := True;
  SetSpecialStatusText(rsclred, '', '');
  CopyList.Pack;
  while Done and (CopyList.Count > 0) do
  begin
    CopyList.Pack;
    Done := False;
    for i := Pred(CopyList.Count) downto 0 do
    begin
      if Assigned(CopyList[i])
        then
        with TFileRec(CopyList[i]^)
          do
          if (Reason = arNewDir) and (not HasKids(AnsiLowerCase(DelBackSlash(Name_Src) + '\'))) then
          begin
            Done := True;
            FreeMem(CopyList[i], SizeOf(TFileRec));
            CopyList[i] := nil;
          end;
    end;
  end;
end;

procedure TfmMain.cbNoEDirClick(Sender: TObject);
begin
  if cbNoEDir.Checked then
  try
    Screen.Cursor := crHourGlass;
    if acDo.Enabled then
    begin
      DeleteEmptyDirs;
      CalcSizes;
      acShow.Enabled := FileCount > 0;
      acDo.Enabled := FileCountLeft > 0;
    end;
  finally
    Screen.Cursor := crDefault;
  end
  else
    NonPossibile;
end;

procedure TfmMain.cbDelClick(Sender: TObject);
begin
  if not cbDel.Checked then
  try
    Screen.Cursor := crHourGlass;
    if acDo.Enabled then
    begin
      ClearList(DelList);
      CalcSizes;
      acShow.Enabled := FileCount > 0;
      acDo.Enabled := FileCountLeft > 0;
    end;
  finally
    Screen.Cursor := crDefault;
  end
  else
    NonPossibile;
end;

procedure TfmMain.lbNoAttrClick(Sender: TObject);
begin
  NonPossibile;
end;

procedure TfmMain.acSwapAllExecute(Sender: TObject);
var
  i: Integer;
  sr: string;
begin
  if lvFList.Items.Count > 0 then
  begin
    NonPossibile;
    for i := 0 to Pred(lvFList.Items.Count)
      do
      with lvFList.Items[i] do
      begin
        sr := Caption;
        Caption := SubItems[1];
        SubItems[1] := sr;
      end;
  end;
end;

procedure TfmMain.PageControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var
  x, y: Integer;
  sr: string;
begin
  if Active then
  begin
    Control.Canvas.Brush.Color := clBtnShadow;
    Control.Canvas.Font.Style := [fsBold];
  end
  else
  begin
    Control.Canvas.Brush.Color := clBtnFace;
    Control.Canvas.Font.Style := [fsUnderline];
  end;

  sr := Copy(PageControl1.Pages[TabIndex].Caption, 2, MaxInt);
  x := (((Rect.Right - Rect.Left) - Control.Canvas.TextWidth(sr)) div 2) + Rect.Left;
  y := (((Rect.Bottom - Rect.Top) - Control.Canvas.TextHeight(sr)) div 2) + Rect.Top;

  Control.Canvas.TextRect(Rect, x, y, sr);

  if Active then
  begin
    Control.Canvas.Font.Style := [fsUnderline, fsBold];
    sr := Copy(PageControl1.Pages[TabIndex].Caption, 2, 1);
    Control.Canvas.TextOut(x, y, sr);
  end;
end;

procedure TfmMain.CreateTaskIcon;
begin
  TIData.Wnd := Handle;
  TIData.uID := TIID;
  TIData.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  TIData.uCallbackMessage := WM_TASKICONEVENT;
  TIData.hIcon := LoadIcon(hInstance, 'ZZTIA');
  StrPCopy(TIData.szTip, DefCapr);
  Shell_NotifyIcon(NIM_ADD, @TIData);
  TaskIcon := True;
  SetTimer(Handle, TITID, 250, nil);
end;

procedure TfmMain.WMTASKICONEVENT(var msg: TMessage);
begin
  if (msg.LParamLo = WM_LBUTTONDBLCLK) and IsMinim then
  begin
    Opts.oAuto := False;
    Opts.oClose := False;
    SetForeGroundWindow(Application.Handle);
    Application.Restore;
  end;
end;

procedure TfmMain.DestroyTaskIcon;
begin
  KillTimer(Handle, TITID);
  TIData.Wnd := Handle;
  TIData.uID := TIID;
  Shell_NotifyIcon(NIM_DELETE, @TIData);
  TaskIcon := False;
end;

procedure TfmMain.WMTIMER(var msg: TWMTIMER);
begin
  if msg.TimerID = TITID then
  begin
    Byte(TIChar) := Byte(TIChar) + 1;
    if TIChar >= 'E'
      then
      TIChar := 'A';
    TIData.hIcon := LoadIcon(HINSTANCE, PChar('ZZTI' + TIChar));
    TIData.uFlags := NIF_ICON;
    Shell_NotifyIcon(NIM_MODIFY, @TIData);
  end;
end;

procedure TfmMain.acDuplicateExecute(Sender: TObject);
var
  ti: TListItem;
begin
  if Assigned(lvFList.Selected) then
  begin
    ti := lvFList.Items.Add;
    ti.Caption := lvFList.Selected.Caption;
    ti.SubItems.Add(lvFList.Selected.SubItems[0]);
    ti.SubItems.Add(lvFList.Selected.SubItems[1]);
    lvFList.Selected := ti;
    lvFList.ItemFocused := ti;
  end;
end;

procedure TfmMain.acResetExecute(Sender: TObject);
begin
  InitOpts(Opts);
  OptsToGui(Opts);
end;

procedure TfmMain.LogStart;
begin
  LogError(Format(rsmStart, [DateTimeToStr(now), defcap, MakeParams]), leInfo);
end;

procedure TfmMain.HaltTaskIcon;
begin
  KillTimer(Handle, TITID);
  StrPCopy(TIData.szTip, DefCapr);
  TIData.hIcon := LoadIcon(hInstance, 'ZZTIX');
  TIData.uFlags := NIF_ICON or NIF_TIP;
  Shell_NotifyIcon(NIM_MODIFY, @TIData);
end;

procedure TfmMain.CheckBtnClick(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    Filter := rsmfCheck;
    Title := rsmtCheck;
    DefaultExt := '';
    FileName := edCheckFileName.Text;
    if Execute
      then
      edCheckFileName.Text := FileName;
  end;

end;

procedure TfmMain.DeleteCheckFileFromDelList;
var
  done: Boolean;
  i: Integer;
begin
  done := True;
  SetSpecialStatusText(rsclred, '', '');
  DelList.Pack;
  while Done and (DelList.Count > 0) do
  begin
    DelList.Pack;
    Done := False;
    for i := Pred(DelList.Count) downto 0 do
    begin
      if Assigned(DelList[i])
        then
        with TFileRec(DelList[i]^)
          do
          if (Reason = arDelFile) and (AnsiCompareFileName(Name_Src, Opts.oCheckFile) = 0) then
          begin
            Done := True;
            FreeMem(DelList[i], SizeOf(TFileRec));
            DelList[i] := nil;
          end;
    end;
  end;
end;

procedure TfmMain.RunBtnClick(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    Filter := rsmfRun;
    Title := rsmtRun;
    DefaultExt := 'EXE';
    FileName := edRunFileName.Text;
    if Execute
      then
      edRunFileName.Text := FileName;
  end;
end;

procedure TfmMain.WMRUNAFTER(var msg: TMessage);
begin
  if (msg.WParam = 17) and (msg.LParam = 4)
    then
    RunFinal(Opts);
end;

procedure TfmMain.edCheckFileNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    CheckBtn.Click;
  end;
end;

procedure TfmMain.edRunFileNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    RunBtn.Click;
  end;
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FormPosSave(Self);
end;

procedure TfmMain.MRUFileList1MRUItemClick(Sender: TObject;
  AFilename: string);
begin
  GetParamsFromControlFile(AFileName, True);
end;

initialization
  defcap := defcapr;
  Ifilemask := TStringList.Create;
  Efilemask := TStringList.Create;
  ftmpList := TStringList.Create;
  OLECheck(SHGetDesktopFolder(gDesktopFolder));
  Opts.oDirList := nil;
  ParseCMDLine;
  // falls shift-taste gedrckt, dann auto und close ausschalten
  if (GetAsyncKeyState(VK_SHIFT) and not 1) <> 0 then
  begin
    Opts.oAuto := False;
    Opts.oClose := False;
    SetForegroundWindow(Application.Handle);
  end;
  OldErrM := SetErrorMode(SEM_FAILCRITICALERRORS);
  InitExProcs;
  ZeroMemory(@TIData, SizeOf(TIData));
  TIData.cbSize := SizeOf(TIData);
finalization
  UnSetPrivilege('SeBackupPrivilege');
  UnSetPrivilege('SeRestorePrivilege');
  ftmpList.Free;
  IFileMask.Free;
  EFileMask.Free;
  if (Opts.oLogWhat <> []) and HasLogged then
  begin
    AddToLog(Opts.oLogName, rsmsep, Opts.oEventLog, leSeparator);
  end;
  ClearOpts(Opts);
  FinalExProcs;
  SetErrorMode(OldErrM);
end.

